"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var grommet_1 = require("grommet");
var React = __importStar(require("react"));
var styled_components_1 = __importStar(require("styled-components"));
var asRendition_1 = __importDefault(require("../../asRendition"));
var useBreakpoint_1 = require("../../hooks/useBreakpoint");
var utils_1 = require("../../utils");
var getHoverEffectOverride = function (bg, color, opacity) {
    return styled_components_1.css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t\t&:hover:enabled,\n\t\t&:focus:enabled,\n\t\t&:active:enabled {\n\t\t\tsvg {\n\t\t\t\tcolor: ", " !important;\n\t\t\t}\n\n\t\t\tbox-shadow: none;\n\t\t\tbackground: ", ";\n\t\t\tborder-color: ", ";\n\t\t\tcolor: ", ";\n\t\t\topacity: ", ";\n\t\t}\n\t"], ["\n\t\t&:hover:enabled,\n\t\t&:focus:enabled,\n\t\t&:active:enabled {\n\t\t\tsvg {\n\t\t\t\tcolor: ", " !important;\n\t\t\t}\n\n\t\t\tbox-shadow: none;\n\t\t\tbackground: ", ";\n\t\t\tborder-color: ", ";\n\t\t\tcolor: ", ";\n\t\t\topacity: ", ";\n\t\t}\n\t"])), color, bg, bg, color, opacity !== null && opacity !== void 0 ? opacity : 'initial');
};
var ButtonBase = styled_components_1.default(grommet_1.Button)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\t& {\n\t\tfont-weight: ", ";\n\t\tfont-size: ", ";\n\t\theight: ", ";\n\t\twhite-space: nowrap;\n\t\tsvg {\n\t\t\tcolor: inherit !important;\n\t\t\tfont-size: 0.925em;\n\t\t}\n\t\t/* These rules cause consistent styling when the button is rendered as a link */\n\t\tdisplay: inline-flex;\n\t\talign-items: center;\n\t\tjustify-content: center;\n\n\t\t&:disabled {\n\t\t\tcursor: not-allowed;\n\t\t}\n\t}\n"], ["\n\t& {\n\t\tfont-weight: ", ";\n\t\tfont-size: ", ";\n\t\theight: ", ";\n\t\twhite-space: nowrap;\n\t\tsvg {\n\t\t\tcolor: inherit !important;\n\t\t\tfont-size: 0.925em;\n\t\t}\n\t\t/* These rules cause consistent styling when the button is rendered as a link */\n\t\tdisplay: inline-flex;\n\t\talign-items: center;\n\t\tjustify-content: center;\n\n\t\t&:disabled {\n\t\t\tcursor: not-allowed;\n\t\t}\n\t}\n"])), function (props) { return props.theme.button.font.weight; }, function (props) { return props.theme.button.font.size; }, function (props) { return props.theme.button.height; });
var ColouredButton = styled_components_1.default(ButtonBase)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n\t& {\n\t\tcolor: ", ";\n\t\t", ";\n\t}\n"], ["\n\t& {\n\t\tcolor: ",
    ";\n\t\t",
    ";\n\t}\n"])), function (props) {
    return utils_1.isLight(utils_1.getColor(props, 'color', 'main'))
        ? props.theme.colors.text.main
        : 'white';
}, function (props) {
    var color = utils_1.getColor(props, 'color', 'dark');
    return getHoverEffectOverride(color, utils_1.isLight(color) ? props.theme.colors.text.main : 'white');
});
var Outline = styled_components_1.default(ButtonBase)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n\t& {\n\t\tcolor: ", ";\n\t\tborder-color: ", ";\n\t\tsvg {\n\t\t\tcolor: ", " !important;\n\t\t}\n\t\t", ";\n\t}\n"], ["\n\t& {\n\t\tcolor: ", ";\n\t\tborder-color: ",
    ";\n\t\tsvg {\n\t\t\tcolor: ", " !important;\n\t\t}\n\t\t",
    ";\n\t}\n"])), function (props) { return props.theme.colors.text.main; }, function (props) {
    return utils_1.getColor(props, 'color', 'main') || props.theme.colors.text.main;
}, function (props) { return props.theme.colors.tertiary.main; }, function (props) {
    return getHoverEffectOverride(props.color || props.theme.colors.text.main, utils_1.isLight(utils_1.getColor(props, 'color', 'main'))
        ? props.theme.colors.text.main
        : 'white');
});
var Light = styled_components_1.default(ButtonBase)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n\t& {\n\t\tcolor: ", ";\n\t\tborder-color: ", ";\n\t\tbackground: white;\n\t\tborder: none;\n\t\t", ";\n\n\t\t&:disabled {\n\t\t\topacity: 1;\n\t\t\tcolor: #c6c8c9;\n\t\t}\n\t}\n"], ["\n\t& {\n\t\tcolor: ", ";\n\t\tborder-color: ", ";\n\t\tbackground: white;\n\t\tborder: none;\n\t\t",
    ";\n\n\t\t&:disabled {\n\t\t\topacity: 1;\n\t\t\tcolor: #c6c8c9;\n\t\t}\n\t}\n"])), function (props) { return props.theme.colors.text.main; }, function (props) { return props.theme.colors.text.main; }, function (props) {
    return getHoverEffectOverride('white', props.theme.colors.secondary.main, '0.9');
});
var LightOutline = styled_components_1.default(Light)(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n\t& {\n\t\tcolor: white;\n\t\tborder: 1px solid white;\n\t\tbackground: transparent;\n\t\t", ";\n\n\t\t&:disabled {\n\t\t\topacity: 1;\n\t\t\tcolor: #c6c8c9;\n\t\t}\n\t}\n"], ["\n\t& {\n\t\tcolor: white;\n\t\tborder: 1px solid white;\n\t\tbackground: transparent;\n\t\t",
    ";\n\n\t\t&:disabled {\n\t\t\topacity: 1;\n\t\t\tcolor: #c6c8c9;\n\t\t}\n\t}\n"])), function (props) {
    return getHoverEffectOverride('white', props.theme.colors.secondary.main, '0.9');
});
var Plain = styled_components_1.default(ButtonBase)(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n\t& {\n\t\tcolor: ", ";\n\t\theight: auto;\n\t\tfont-weight: ", ";\n\t\tborder-radius: 0;\n\t\t", ";\n\t}\n"], ["\n\t& {\n\t\tcolor: ",
    ";\n\t\theight: auto;\n\t\tfont-weight: ", ";\n\t\tborder-radius: 0;\n\t\t",
    ";\n\t}\n"])), function (props) {
    return utils_1.getColor(props, 'color', 'main') || props.theme.colors.text.main;
}, function (props) { return props.theme.button.font.weight; }, function (props) {
    return getHoverEffectOverride('none', utils_1.getColor(props, 'color', 'dark') || props.theme.colors.text.light);
});
var underlineButtonActiveStyles = function (props) { return styled_components_1.css(templateObject_8 || (templateObject_8 = __makeTemplateObject(["\n\t& {\n\t\tcolor: ", ";\n\t\tbackground: none;\n\t\tbox-shadow: 0px -1px 0 0px inset;\n\t}\n"], ["\n\t& {\n\t\tcolor: ", ";\n\t\tbackground: none;\n\t\tbox-shadow: 0px -1px 0 0px inset;\n\t}\n"])), utils_1.getColor(props, 'color', 'main') || props.theme.colors.text.main); };
var Underline = styled_components_1.default(Plain)(templateObject_9 || (templateObject_9 = __makeTemplateObject(["\n\t& {\n\t\t", "\n\t\tborder-bottom: 1px solid;\n\t\tbackground: none;\n\t\t&:hover:enabled,\n\t\t&:focus:enabled,\n\t\t&:active:enabled {\n\t\t\t", ";\n\t\t}\n\t}\n"], ["\n\t& {\n\t\t", "\n\t\tborder-bottom: 1px solid;\n\t\tbackground: none;\n\t\t&:hover:enabled,\n\t\t&:focus:enabled,\n\t\t&:active:enabled {\n\t\t\t", ";\n\t\t}\n\t}\n"])), function (props) { return (props.active ? underlineButtonActiveStyles(props) : ''); }, underlineButtonActiveStyles);
var getStyledButton = function (_a, isPrimary) {
    var outline = _a.outline, underline = _a.underline, plain = _a.plain, active = _a.active, light = _a.light;
    if (plain) {
        return Plain;
    }
    if (light) {
        if (outline) {
            return LightOutline;
        }
        return Light;
    }
    if (underline) {
        return Underline;
    }
    if ((outline && !active) || !isPrimary) {
        return Outline;
    }
    return ColouredButton;
};
var Base = function (props) {
    var outline = props.outline, underline = props.underline, children = props.children, label = props.label, primary = props.primary, color = props.color, plain = props.plain, active = props.active, light = props.light, compact = props.compact, restProps = __rest(props, ["outline", "underline", "children", "label", "primary", "color", "plain", "active", "light", "compact"]);
    var shouldCompact = useBreakpoint_1.useBreakpoint(compact || [false]);
    var basePrimary = !!props.bg ||
        (!!utils_1.getColoringType(props) && !outline && !underline && !props.plain);
    var baseColor = props.bg || utils_1.getColor(props, 'bg', 'main');
    baseColor = baseColor || props.theme.colors.secondary.main;
    if (active) {
        basePrimary = !basePrimary;
    }
    var StyledButton = getStyledButton({ underline: underline, plain: plain, active: active, light: light }, basePrimary);
    return (React.createElement(StyledButton, __assign({ primary: basePrimary, color: baseColor, active: active && (underline || plain), gap: utils_1.px(props.theme.space[2]) }, restProps, { plain: !!plain || !!underline, label: shouldCompact ? undefined : label || children })));
};
exports.default = asRendition_1.default(Base, [], ['width', 'color', 'bg']);
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8, templateObject_9;
