"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var map_1 = __importDefault(require("lodash/map"));
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var asRendition_1 = __importDefault(require("../../asRendition"));
var DismissableContainer_1 = require("../../internal/DismissableContainer");
var Box_1 = require("../Box");
var Divider_1 = __importDefault(require("../Divider"));
var Flex_1 = require("../Flex");
var Heading_1 = __importDefault(require("../Heading"));
var Wrapper = styled_components_1.default(DismissableContainer_1.DismissableContainer)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t& {\n\t\tpadding: ", ";\n\t}\n"], ["\n\t& {\n\t\tpadding: ", ";\n\t}\n"])), function (props) { return (props.small ? '24px' : '32px 44px'); });
var Card = function (_a) {
    var title = _a.title, cta = _a.cta, rows = _a.rows, children = _a.children, props = __rest(_a, ["title", "cta", "rows", "children"]);
    var hasHeader = title || cta;
    var Header = hasHeader && (React.createElement(React.Fragment, null,
        React.createElement(Flex_1.Flex, { justifyContent: "space-between", alignItems: "center" },
            React.createElement(Heading_1.default.h5, { fontSize: 4 }, title),
            cta),
        React.createElement(Divider_1.default, { my: 2 })));
    var Rows = rows &&
        map_1.default(rows, function (row, index) { return (React.createElement(Box_1.Box, { key: index, fontSize: 2 },
            index > 0 && React.createElement(Divider_1.default, null),
            row)); });
    var Body = children && React.createElement(Box_1.Box, { fontSize: 2 }, children);
    return (React.createElement(Wrapper, __assign({}, props),
        React.createElement(Box_1.Box, { width: "100%" },
            Header,
            Rows,
            Body)));
};
exports.default = asRendition_1.default(Card);
var templateObject_1;
