import { JSONSchema7 as JSONSchema } from 'json-schema';
import * as React from 'react';
import { DataTypeEditProps } from '../Filters';
import { InputProps } from '../Input';
import { TextareaProps } from '../Textarea';
export declare const operators: {
    contains: {
        getLabel: (_s: JSONSchema) => string;
    };
    not_contains: {
        getLabel: (_s: JSONSchema) => string;
    };
};
declare type OperatorSlug = keyof typeof operators;
interface StringFilter extends JSONSchema {
    title: OperatorSlug;
    properties?: {
        [k: string]: {
            not?: {
                contains: {
                    const: string;
                };
            };
            contains?: {
                const: string;
            };
        };
    };
    anyOf?: Array<{
        properties?: {
            [k: string]: {
                not?: {
                    contains: {
                        const: string;
                    };
                };
                contains?: {
                    const: string;
                };
            };
        };
    }>;
}
export declare const decodeFilter: (filter: StringFilter) => {
    field: string;
    operator: OperatorSlug;
    value: string;
} | null;
export declare const createFilter: (field: string, operator: OperatorSlug, value: any, schema: JSONSchema) => JSONSchema;
export declare const Edit: ({ onUpdate, slim, ...props }: DataTypeEditProps & import("../Textarea").InternalTextareaProps & import("../..").Tooltip & import("../..").StyledSystemProps & import("../Input").InternalInputProps & {
    ref?: ((instance: HTMLInputElement | null) => void) | React.RefObject<HTMLInputElement | null> | null | undefined;
} & {
    slim?: boolean | undefined;
}) => JSX.Element;
export {};
