"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FilterModal = void 0;
var faTimes_1 = require("@fortawesome/free-solid-svg-icons/faTimes");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var map_1 = __importDefault(require("lodash/map"));
var react_1 = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var Button_1 = __importDefault(require("../Button"));
var Box_1 = require("../Box");
var DataTypes_1 = require("../DataTypes");
var Flex_1 = require("../Flex");
var Modal_1 = __importDefault(require("../Modal"));
var Select_1 = __importDefault(require("../Select"));
var Txt_1 = __importDefault(require("../Txt"));
var SchemaSieve = __importStar(require("./SchemaSieve"));
var FilterInput = function (props) {
    var model = DataTypes_1.getDataModel(props.schema);
    if (!model) {
        return null;
    }
    var Edit = model.Edit;
    return (react_1.default.createElement(Edit, { schema: props.schema, value: props.value, operator: props.operator, onUpdate: props.onUpdate, slim: true }));
};
var RelativeBox = styled_components_1.default(Box_1.Box)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tposition: relative;\n"], ["\n\tposition: relative;\n"])));
var DeleteButton = styled_components_1.default(Button_1.default)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tcolor: rgba(0, 0, 0, 0.4);\n\tposition: absolute;\n\tbottom: 7px;\n\tright: -35px;\n"], ["\n\tcolor: rgba(0, 0, 0, 0.4);\n\tposition: absolute;\n\tbottom: 7px;\n\tright: -35px;\n"])));
exports.FilterModal = function (_a) {
    var addFilter = _a.addFilter, onClose = _a.onClose, schema = _a.schema, edit = _a.edit;
    var _b = react_1.useState(edit), filters = _b[0], setFilters = _b[1];
    var setEditField = function (field, index) {
        var currentEdit = filters.map(function (filter, i) {
            return i === index ? SchemaSieve.getCleanEditModel(schema, field) : filter;
        });
        setFilters(currentEdit);
    };
    var setEditOperator = function (operator, index) {
        var currentEdit = filters.map(function (filter, i) {
            return i === index ? __assign(__assign({}, filter), { operator: operator }) : filter;
        });
        setFilters(currentEdit);
    };
    var setEditValue = function (value, index) {
        var currentEdit = filters.map(function (filter, i) {
            return i === index ? __assign(__assign({}, filter), { value: value }) : filter;
        });
        setFilters(currentEdit);
    };
    var removeCompound = function (index) {
        var currentEdit = filters.reduce(function (acc, cur, i) { return (i === index ? acc : __spreadArrays(acc, [cur])); }, []);
        setFilters(currentEdit);
    };
    return (react_1.default.createElement(Modal_1.default, { title: "Filter by", cancel: onClose, done: function () { return addFilter(filters); }, action: "Save" },
        filters.map(function (_a, index) {
            var field = _a.field, operator = _a.operator, value = _a.value;
            var operators = SchemaSieve.getOperators(schema, field);
            return (react_1.default.createElement(RelativeBox, { key: index },
                index > 0 && react_1.default.createElement(Txt_1.default, { my: 2 }, "OR"),
                react_1.default.createElement(Flex_1.Flex, null,
                    react_1.default.createElement(Box_1.Box, { flex: 1 },
                        react_1.default.createElement(Select_1.default, { options: map_1.default(schema.properties, function (s, field) { return ({
                                field: field,
                                title: s.title || field,
                            }); }), valueKey: "field", labelKey: "title", value: schema.properties
                                ? {
                                    field: field,
                                    title: schema.properties[field].title ||
                                        field,
                                }
                                : { field: field }, onChange: function (_a) {
                                var option = _a.option;
                                return setEditField(option.field, index);
                            } })),
                    operators.length === 1 && (react_1.default.createElement(Txt_1.default, { py: 2, px: 3, align: "center" }, operators[0].label)),
                    operators.length > 1 && (react_1.default.createElement(Box_1.Box, { flex: 1, mx: 1 },
                        react_1.default.createElement(Select_1.default, { options: operators, valueKey: "slug", labelKey: "label", value: operators.find(function (x) { return x.slug === operator; }), onChange: function (_a) {
                                var option = _a.option;
                                return setEditOperator(option.slug, index);
                            } }))),
                    react_1.default.createElement(Box_1.Box, { flex: 1 },
                        react_1.default.createElement(FilterInput, { operator: operator, value: value, schema: schema.properties[field], onUpdate: function (v) { return setEditValue(v, index); } }))),
                index > 0 && (react_1.default.createElement(DeleteButton, { plain: true, fontSize: 1, p: 1, onClick: function () { return removeCompound(index); } },
                    react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faTimes_1.faTimes })))));
        }),
        react_1.default.createElement(Button_1.default, { mb: 2, mt: 4, primary: true, underline: true, onClick: function () {
                return setFilters(filters.concat(SchemaSieve.getCleanEditModel(schema)));
            } }, "Add alternative")));
};
var templateObject_1, templateObject_2;
