"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var faTrashAlt_1 = require("@fortawesome/free-regular-svg-icons/faTrashAlt");
var faArrowDown_1 = require("@fortawesome/free-solid-svg-icons/faArrowDown");
var faArrowUp_1 = require("@fortawesome/free-solid-svg-icons/faArrowUp");
var faPlus_1 = require("@fortawesome/free-solid-svg-icons/faPlus");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var React = __importStar(require("react"));
var Flex_1 = require("../../Flex");
var Box_1 = require("../../Box");
var Button_1 = __importDefault(require("../../Button"));
var WarningField_1 = require("../WarningField");
var ArrayFieldTitle = function (_a) {
    var TitleField = _a.TitleField, idSchema = _a.idSchema, required = _a.required, title = _a.title;
    if (!title) {
        return null;
    }
    var id = idSchema.$id + "__title";
    return React.createElement(TitleField, { id: id, title: title, required: required });
};
var ArrayFieldDescription = function (_a) {
    var DescriptionField = _a.DescriptionField, idSchema = _a.idSchema, description = _a.description;
    if (!description) {
        return null;
    }
    var id = idSchema.$id + "__description";
    return React.createElement(DescriptionField, { id: id, description: description });
};
exports.default = (function (props) {
    var _a, _b;
    var warning = props.uiSchema['ui:warning'];
    var orderable = (_b = (_a = props.uiSchema['ui:options']) === null || _a === void 0 ? void 0 : _a.orderable) !== null && _b !== void 0 ? _b : true;
    return (React.createElement("div", { className: props.uiSchema.classNames },
        React.createElement(ArrayFieldTitle, { TitleField: props.TitleField, idSchema: props.idSchema, title: props.uiSchema['ui:title'] || props.title, required: props.required }),
        !!warning && React.createElement(WarningField_1.WarningField, { warning: warning }),
        React.createElement(ArrayFieldDescription, { DescriptionField: props.DescriptionField, idSchema: props.idSchema, description: props.uiSchema['ui:description'] || props.schema.description }),
        props.items.map(function (element) {
            return (React.createElement("div", { className: "rendition-form__array-item", key: element.index },
                React.createElement(Flex_1.Flex, { alignItems: "flex-start" },
                    React.createElement(Box_1.Box, { flex: "1" }, element.children),
                    React.createElement(Box_1.Box, null,
                        orderable && props.items.length > 1 && (React.createElement(Button_1.default, { type: "button", className: "rendition-form-array-item__move-up", py: 1, px: 2, primary: true, plain: true, disabled: element.disabled || element.readonly || !element.hasMoveUp, onClick: element.onReorderClick(element.index, element.index - 1) },
                            React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faArrowUp_1.faArrowUp }))),
                        orderable && props.items.length > 1 && (React.createElement(Button_1.default, { type: "button", className: "rendition-form-array-item__move-down", py: 1, px: 2, plain: true, primary: true, disabled: element.disabled ||
                                element.readonly ||
                                !element.hasMoveDown, onClick: element.onReorderClick(element.index, element.index + 1) },
                            React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faArrowDown_1.faArrowDown }))),
                        element.hasRemove && (React.createElement(Button_1.default, { type: "button", className: "rendition-form-array-item__remove-item", plain: true, primary: true, py: 1, px: 2, disabled: element.disabled || element.readonly, onClick: element.onDropIndexClick(element.index) },
                            React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faTrashAlt_1.faTrashAlt })))))));
        }),
        props.canAdd && (React.createElement(Button_1.default, { mt: 3, type: "button", className: "rendition-form-array-item__add-item", icon: React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faPlus_1.faPlus }), onClick: props.onAddClick }, "Add item"))));
});
