"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var Input_1 = __importDefault(require("../../Input"));
var filterSuggestions = function (text, suggestions) {
    if (!text || !suggestions) {
        return suggestions;
    }
    return suggestions.filter(function (suggestion) { return suggestion.includes(text) && suggestion !== text; });
};
var BaseInput = function (props) {
    var _a, _b;
    var value = props.value, readonly = props.readonly, disabled = props.disabled, autofocus = props.autofocus, onBlur = props.onBlur, onFocus = props.onFocus, options = props.options, schema = props.schema, formContext = props.formContext, dir = props.dir, inputProps = __rest(props, ["value", "readonly", "disabled", "autofocus", "onBlur", "onFocus", "options", "schema", "formContext", "dir"]);
    var change = function (_a) {
        var value = _a.target.value;
        return props.onChange(value === '' ? options.emptyValue : value);
    };
    var suggestions = filterSuggestions(value, schema.examples);
    var hasExamples = ((_b = (_a = schema.examples) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0) > 0;
    return (React.createElement(React.Fragment, null,
        React.createElement(Input_1.default, __assign({ width: "100%", readOnly: readonly, disabled: disabled, autoFocus: autofocus, autoComplete: hasExamples ? 'off' : options.autoComplete, emphasized: options.emphasized, value: value == null ? '' : value, type: schema.type === 'number'
                ? 'number'
                : options.inputType || 'text', dir: dir }, inputProps, { onChange: change, onBlur: onBlur && (function (event) { return onBlur(inputProps.id, event.target.value); }), onFocus: onFocus &&
                (function (event) { return onFocus(inputProps.id, event.target.value); }), onSelect: function (e) { return props.onChange(e.suggestion); }, suggestions: suggestions, list: hasExamples ? 'dummy-datalist' : undefined })),
        hasExamples && React.createElement("datalist", { id: "dummy-datalist" })));
};
exports.default = BaseInput;
