"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var faEye_1 = require("@fortawesome/free-regular-svg-icons/faEye");
var faEyeSlash_1 = require("@fortawesome/free-regular-svg-icons/faEyeSlash");
var utils_1 = require("../../../utils");
var Button_1 = __importDefault(require("../../Button"));
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var STRENGTH_TITLES = ['Very weak', 'Weak', 'Good', 'Strong', 'Very strong'];
var STRENGTH_STYLES = [
    { width: 0 },
    { width: '25%', backgroundColor: 'orange' },
    { width: '50%', backgroundColor: 'yellow' },
    { width: '75%', backgroundColor: 'green' },
    { width: '100%', backgroundColor: 'darkgreen' },
];
var PasswordStrengthContainer = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tpadding-bottom: ", ";\n\tposition: relative;\n\tmargin-top: ", ";\n\tmargin-bottom: ", ";\n\tfont-size: ", ";\n"], ["\n\tpadding-bottom: ", ";\n\tposition: relative;\n\tmargin-top: ", ";\n\tmargin-bottom: ", ";\n\tfont-size: ", ";\n"])), function (props) { return utils_1.px(props.theme.space[1]); }, function (props) { return utils_1.px(props.theme.space[2]); }, function (props) { return utils_1.px(props.theme.space[3]); }, function (props) { return utils_1.px(props.theme.fontSizes[0]); });
var ShowPasswordButton = styled_components_1.default(Button_1.default)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tposition: absolute;\n\tright: ", ";\n\ttop: 50%;\n\ttransform: translate(0, -50%);\n"], ["\n\tposition: absolute;\n\tright: ", ";\n\ttop: 50%;\n\ttransform: translate(0, -50%);\n"])), function (props) { return utils_1.px(props.theme.space[2]); });
var PasswordStrengthMeter = styled_components_1.default.div(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n\ttransition: all ease-out 150ms;\n\tposition: absolute;\n\theight: 4px;\n\tbackground-color: red;\n\tmin-width: 5px;\n\tbottom: 0;\n"], ["\n\ttransition: all ease-out 150ms;\n\tposition: absolute;\n\theight: 4px;\n\tbackground-color: red;\n\tmin-width: 5px;\n\tbottom: 0;\n"])));
var PasswordStrengthText = styled_components_1.default.p(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n\tmargin: 0;\n\tmargin-bottom: ", ";\n"], ["\n\tmargin: 0;\n\tmargin-bottom: ", ";\n"])), function (props) { return utils_1.px(props.theme.space[2]); });
var PasswordStrength = function (_a) {
    var password = _a.password;
    var _b = React.useState(), strengthScore = _b[0], setStrengthScore = _b[1];
    React.useEffect(function () {
        var zxcvbn = window.zxcvbn;
        if (zxcvbn && password) {
            try {
                var score = zxcvbn(password).score;
                setStrengthScore(score);
            }
            catch (_a) {
            }
        }
    }, [password]);
    if (!password || strengthScore === undefined) {
        return null;
    }
    return (React.createElement(PasswordStrengthContainer, null,
        React.createElement(PasswordStrengthText, null,
            "Password strength: ",
            React.createElement("em", null, STRENGTH_TITLES[strengthScore])),
        React.createElement(PasswordStrengthMeter, { style: STRENGTH_STYLES[strengthScore] })));
};
var PasswordWidget = function (props) {
    var BaseInput = props.registry.widgets.BaseInput;
    var _a = React.useState(false), showPassword = _a[0], setShowPassword = _a[1];
    return (React.createElement(React.Fragment, null,
        React.createElement("div", { style: { position: 'relative' } },
            React.createElement(BaseInput, __assign({ pr: 4, type: showPassword ? 'text' : 'password' }, props)),
            React.createElement(ShowPasswordButton, { p: 2, plain: true, icon: React.createElement(react_fontawesome_1.FontAwesomeIcon, { fixedWidth: true, icon: showPassword ? faEye_1.faEye : faEyeSlash_1.faEyeSlash }), onClick: function () { return setShowPassword(function (x) { return !x; }); } })),
        props.options.showPasswordStrengthMeter && (React.createElement(PasswordStrength, { password: props.value }))));
};
exports.default = PasswordWidget;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4;
