"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var grommet_1 = require("grommet");
var React = __importStar(require("react"));
var styled_components_1 = __importStar(require("styled-components"));
var utils_1 = require("../../utils");
var Box_1 = require("../Box");
var Button_1 = __importDefault(require("../Button"));
var Flex_1 = require("../Flex");
var Heading_1 = __importDefault(require("../Heading"));
var Txt_1 = __importDefault(require("../Txt"));
var bodyNoOverflowClass = "rendition-modal-open";
var GlobalStyle = styled_components_1.createGlobalStyle(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t.", " {\n\t\toverflow: hidden;\n\t}\n"], ["\n\t.", " {\n\t\toverflow: hidden;\n\t}\n"])), bodyNoOverflowClass);
var DEFAULT_MODAL_WIDTH = 700;
var ModalSizer = styled_components_1.default(Box_1.Box)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\toverflow-y: auto;\n"], ["\n\toverflow-y: auto;\n"])));
var HeadingDescription = styled_components_1.default(Txt_1.default)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n\tfont-weight: normal;\n"], ["\n\tfont-weight: normal;\n"])));
var ModalButton = function (props) {
    return 'href' in props && props.href ? (React.createElement(Button_1.default, __assign({ as: "a" }, props))) : (React.createElement(Button_1.default, __assign({}, props)));
};
var Modal = (function (_super) {
    __extends(Modal, _super);
    function Modal(props) {
        var _this = _super.call(this, props) || this;
        _this.ownIndex = 0;
        _this.handleKeyDown = function (e) {
            var _a;
            if (Modal.mountedCount !== _this.ownIndex) {
                return;
            }
            if (!e.defaultPrevented && e.which === 13) {
                e.preventDefault();
                e.stopPropagation();
                if ((_a = _this.props.primaryButtonProps) === null || _a === void 0 ? void 0 : _a.disabled) {
                    return;
                }
                if (e.which === 13) {
                    _this.props.done();
                }
            }
        };
        _this.stopPropagation = function (e) {
            return e.stopPropagation();
        };
        _this.popModal = function () {
            if (Modal.mountedCount !== _this.ownIndex) {
                return;
            }
            (_this.props.cancel || _this.props.done)();
        };
        return _this;
    }
    Modal.prototype.componentDidMount = function () {
        if (!Modal.mountedCount) {
            document.body.classList.add(bodyNoOverflowClass);
        }
        window.document.addEventListener('keydown', this.handleKeyDown);
        Modal.mountedCount++;
        this.ownIndex = Modal.mountedCount;
    };
    Modal.prototype.componentWillUnmount = function () {
        Modal.mountedCount--;
        if (!Modal.mountedCount) {
            document.body.classList.remove(bodyNoOverflowClass);
        }
        window.document.removeEventListener('keydown', this.handleKeyDown);
    };
    Modal.prototype.render = function () {
        var _a = this.props, width = _a.width, theme = _a.theme, props = __rest(_a, ["width", "theme"]);
        var cancelButtonProps = Object.assign({ style: { marginRight: 20 } }, props.cancelButtonProps);
        var secondaryButtonProps = Object.assign({
            primary: true,
            outline: true,
            style: { marginRight: 20 },
        }, props.secondaryButtonProps);
        var primaryButtonProps = Object.assign({ primary: true }, props.primaryButtonProps);
        return (React.createElement(grommet_1.Layer, { onEsc: this.popModal, onClickOutside: this.popModal, responsive: false, position: props.position || 'center', margin: "small", animate: false, style: {
                marginTop: props.position === 'top' ? theme.header.height : undefined,
            } },
            React.createElement(GlobalStyle, null),
            React.createElement(ModalSizer, { width: width || DEFAULT_MODAL_WIDTH, maxWidth: "100%", onClick: this.stopPropagation, style: props.style, id: props.id, className: props.className },
                React.createElement(Box_1.Box, { p: [utils_1.px(theme.space[3]), '40px 50px 30px'] },
                    props.titleElement ? (React.createElement(Heading_1.default.h3, { mb: 50 }, props.titleElement)) : (!!props.title && (React.createElement(Heading_1.default.h3, { mb: 50 },
                        props.title,
                        !!props.titleDetails && (React.createElement(HeadingDescription, { color: "text.light", fontSize: 2 }, props.titleDetails))))),
                    props.children,
                    React.createElement(Flex_1.Flex, { mt: 50, alignItems: "center", justifyContent: "flex-end" },
                        props.cancel && (React.createElement(ModalButton, __assign({}, cancelButtonProps, { onClick: props.cancel }), (cancelButtonProps && cancelButtonProps.children) ||
                            'Cancel')),
                        props.secondaryButtonProps && (React.createElement(ModalButton, __assign({}, secondaryButtonProps))),
                        React.createElement(ModalButton, __assign({}, primaryButtonProps, { onClick: props.done }), props.action || 'OK'))))));
    };
    Modal.mountedCount = 0;
    return Modal;
}(React.Component));
exports.default = styled_components_1.withTheme(Modal);
var templateObject_1, templateObject_2, templateObject_3;
