"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BreakpointProvider = void 0;
var debounce_1 = __importDefault(require("lodash/debounce"));
var React = __importStar(require("react"));
var BreakpointContext_1 = require("../../contexts/BreakpointContext");
exports.BreakpointProvider = function (_a) {
    var breakpoints = _a.breakpoints, children = _a.children;
    var _b = React.useState(0), currentBreakpoint = _b[0], setCurrentBreakpoint = _b[1];
    React.useEffect(function () {
        if (!breakpoints || !breakpoints.length) {
            return;
        }
        var handleResize = function () {
            var clientWidth = window.innerWidth;
            var breakpointIndex = breakpoints.findIndex(function (breakpoint) { return clientWidth < breakpoint; });
            var currentBreakpoint = breakpointIndex >= 0 ? breakpointIndex : breakpoints.length - 1;
            setCurrentBreakpoint(currentBreakpoint);
        };
        var debouncedResize = debounce_1.default(handleResize, 80);
        handleResize();
        window.addEventListener('resize', debouncedResize, { passive: false });
        return function () {
            window.removeEventListener('resize', debouncedResize);
        };
    }, [breakpoints]);
    return (React.createElement(BreakpointContext_1.BreakpointContext.Provider, { value: { currentBreakpoint: currentBreakpoint } }, children));
};
exports.BreakpointProvider.displayName = 'BreakpointProvider';
