"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var monacoEditor = __importStar(require("monaco-editor/esm/vs/editor/editor.api"));
var react_monaco_editor_1 = __importDefault(require("react-monaco-editor"));
var get_1 = __importDefault(require("lodash/get"));
var cloneDeep_1 = __importDefault(require("lodash/cloneDeep"));
var findIndex_1 = __importDefault(require("lodash/findIndex"));
var styled_components_1 = __importDefault(require("styled-components"));
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var faExclamationCircle_1 = require("@fortawesome/free-solid-svg-icons/faExclamationCircle");
var faCheckCircle_1 = require("@fortawesome/free-solid-svg-icons/faCheckCircle");
var Flex_1 = require("../../../components/Flex");
var Box_1 = require("../../../components/Box");
var Heading_1 = __importDefault(require("../../../components/Heading"));
var EditorWrapper = styled_components_1.default(Flex_1.Flex)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tborder: 1px solid\n\t\t", ";\n"], ["\n\tborder: 1px solid\n\t\t",
    ";\n"])), function (props) {
    return props.isValid
        ? props.theme.colors.quartenary.main
        : props.theme.colors.danger.main;
});
var ValidationBox = styled_components_1.default(Box_1.Box)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tcolor: ", ";\n"], ["\n\tcolor: ",
    ";\n"])), function (props) {
    return props.hasError
        ? props.theme.colors.danger.main
        : props.theme.colors.success.main;
});
var defaultOptions = {
    minimap: {
        enabled: false,
    },
    lineNumbers: 'off',
    tabSize: 2,
    detectIndentation: false,
    selectOnLineNumbers: true,
};
var monacoEditorSchemas = cloneDeep_1.default(get_1.default(monacoEditor, ['languages', 'json', 'jsonDefaults', 'diagnosticsOptions', 'schemas'], []));
var getModel = function (fileUri, valueStr) {
    var model = monacoEditor.editor.getModel(fileUri) ||
        monacoEditor.editor.createModel(valueStr, 'json', fileUri);
    model.updateOptions({ tabSize: 2 });
    return model;
};
var JsonEditor = function (_a) {
    var title = _a.title, value = _a.value, onChange = _a.onChange, schema = _a.schema, isValid = _a.isValid;
    var fileName = "file:///" + title + ".json";
    var fileUri = monacoEditor.Uri.parse(fileName);
    var _b = React.useState(getModel(fileUri, value)), model = _b[0], setModel = _b[1];
    React.useEffect(function () {
        setModel(getModel(fileUri, value));
    }, [title, value]);
    React.useEffect(function () {
        if (!schema) {
            return;
        }
        var thisSchema = {
            uri: schema['$schema'] || fileUri.toString(),
            fileMatch: [fileUri.toString()],
            schema: schema,
        };
        var existingSchemaIndex = findIndex_1.default(monacoEditorSchemas, {
            uri: thisSchema.uri,
        });
        if (existingSchemaIndex !== -1) {
            monacoEditorSchemas.splice(existingSchemaIndex, 1, thisSchema);
        }
        else {
            monacoEditorSchemas.push(thisSchema);
        }
        monacoEditor.languages.json.jsonDefaults.setDiagnosticsOptions({
            validate: true,
            schemas: monacoEditorSchemas,
        });
    }, [schema]);
    return (React.createElement(Flex_1.Flex, { flex: "1 1 0", flexDirection: "column" },
        React.createElement(Flex_1.Flex, { justifyContent: "space-between", alignItems: "center" },
            title && React.createElement(Heading_1.default.h5, null, title),
            React.createElement(ValidationBox, { hasError: !isValid, tooltip: "JSON is " + (isValid ? 'valid' : 'invalid') },
                React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: isValid ? faCheckCircle_1.faCheckCircle : faExclamationCircle_1.faExclamationCircle }))),
        React.createElement(EditorWrapper, { flex: 1, mb: 2, isValid: isValid },
            React.createElement(react_monaco_editor_1.default, { language: "json", theme: "vs", height: "100%", options: __assign(__assign({}, defaultOptions), { model: model }), value: value, onChange: onChange }))));
};
exports.default = JsonEditor;
var templateObject_1, templateObject_2;
