"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var keys_1 = __importDefault(require("lodash/keys"));
var get_1 = __importDefault(require("lodash/get"));
var escapeRegExp_1 = __importDefault(require("lodash/escapeRegExp"));
var filter_1 = __importDefault(require("lodash/filter"));
var memoize_1 = __importDefault(require("lodash/memoize"));
var json_schema_draft_07_json_1 = __importDefault(require("ajv/lib/refs/json-schema-draft-07.json"));
var styled_components_1 = __importDefault(require("styled-components"));
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var faUndo_1 = require("@fortawesome/free-solid-svg-icons/faUndo");
var asRendition_1 = __importDefault(require("../../../asRendition"));
var Flex_1 = require("../../../components/Flex");
var Box_1 = require("../../../components/Box");
var Card_1 = __importDefault(require("../../../components/Card"));
var Select_1 = __importDefault(require("../../../components/Select"));
var Button_1 = __importDefault(require("../../../components/Button"));
var Heading_1 = __importDefault(require("../../../components/Heading"));
var Checkbox_1 = __importDefault(require("../../../components/Checkbox"));
var index_1 = __importDefault(require("../index"));
var examples_1 = require("../examples");
var JsonEditor_1 = __importDefault(require("./JsonEditor"));
var util_1 = require("./util");
var EXTRA_FORMATS = [
    {
        name: 'markdown',
        format: '.*',
    },
];
var SlimCard = styled_components_1.default(Card_1.default)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t& > div {\n\t\tflex: 1;\n\t\tdisplay: flex;\n\t\tflex-direction: column;\n\t}\n"], ["\n\t& > div {\n\t\tflex: 1;\n\t\tdisplay: flex;\n\t\tflex-direction: column;\n\t}\n"])));
var ResultCard = styled_components_1.default(SlimCard)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\t& > div > div:last-child {\n\t\tdisplay: flex;\n\t}\n"], ["\n\t& > div > div:last-child {\n\t\tdisplay: flex;\n\t}\n"])));
var EditCard = styled_components_1.default(SlimCard)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n\t& > div > div {\n\t\tflex: 1;\n\t\tdisplay: flex;\n\t\tflex-direction: column;\n\t\tmin-height: 0;\n\t}\n"], ["\n\t& > div > div {\n\t\tflex: 1;\n\t\tdisplay: flex;\n\t\tflex-direction: column;\n\t\tmin-height: 0;\n\t}\n"])));
var defaultJsonProps = { value: {}, schema: {}, uiSchema: {} };
var defaultRegExp = new RegExp('');
var getExampleNames = memoize_1.default(function (examples) { return keys_1.default(examples); });
var commonCardProps = {
    small: true,
    backgroundColor: 'quartenary.light',
};
var JsonSchemaRendererPlayground = function (_a) {
    var _b = _a.title, title = _b === void 0 ? 'JSON Playground' : _b, examples = _a.examples, props = __rest(_a, ["title", "examples"]);
    var _c = React.useState(true), validate = _c[0], setValidate = _c[1];
    var _d = React.useState(''), selectedExample = _d[0], setSelectedExample = _d[1];
    var _e = React.useState(defaultRegExp), searchTermRegExp = _e[0], setSearchTermRegExp = _e[1];
    var _f = React.useState({}), value = _f[0], setValue = _f[1];
    var _g = React.useState({}), schema = _g[0], setSchema = _g[1];
    var _h = React.useState({}), uiSchema = _h[0], setUiSchema = _h[1];
    var _j = React.useState(JSON.stringify(value, null, 2)), valueStr = _j[0], setValueStr = _j[1];
    var _k = React.useState(JSON.stringify(schema, null, 2)), schemaStr = _k[0], setSchemaStr = _k[1];
    var _l = React.useState(JSON.stringify(uiSchema, null, 2)), uiSchemaStr = _l[0], setUiSchemaStr = _l[1];
    var _m = React.useState(true), isValueJsonValid = _m[0], setIsValueJsonValid = _m[1];
    var _o = React.useState(true), isSchemaJsonValid = _o[0], setIsSchemaJsonValid = _o[1];
    var _p = React.useState(true), isUiSchemaJsonValid = _p[0], setIsUiSchemaJsonValid = _p[1];
    var _q = React.useState({}), uiSchemaMetaSchema = _q[0], setUiSchemaMetaSchema = _q[1];
    var _r = React.useState(defaultJsonProps), jsonProps = _r[0], setJsonProps = _r[1];
    var reset = React.useCallback(function () {
        setSelectedExample('');
        setSearchTermRegExp(defaultRegExp);
    }, [setSelectedExample, setSearchTermRegExp]);
    React.useEffect(function () {
        try {
            setValue(JSON.parse(valueStr));
            setIsValueJsonValid(true);
        }
        catch (_a) {
            setIsValueJsonValid(false);
        }
    }, [valueStr]);
    React.useEffect(function () {
        try {
            setSchema(JSON.parse(schemaStr));
            setIsSchemaJsonValid(true);
        }
        catch (_a) {
            setIsSchemaJsonValid(false);
        }
    }, [schemaStr]);
    React.useEffect(function () {
        try {
            setUiSchema(JSON.parse(uiSchemaStr));
            setIsUiSchemaJsonValid(true);
        }
        catch (_a) {
            setIsUiSchemaJsonValid(false);
        }
    }, [uiSchemaStr]);
    React.useEffect(function () {
        var example = get_1.default(examples, selectedExample, defaultJsonProps);
        setValueStr(JSON.stringify(example.value, null, 2));
        setSchemaStr(JSON.stringify(example.schema, null, 2));
        setUiSchemaStr(JSON.stringify(example.uiSchema, null, 2));
        setSearchTermRegExp(defaultRegExp);
    }, [selectedExample]);
    React.useEffect(function () {
        try {
            var newMetaSchema = util_1.generateUiSchemaMetaSchema({
                value: value,
                schema: schema,
                uiSchema: uiSchema,
                extraContext: __assign(__assign({}, examples_1.CONTEXT_FUNCTIONS), { root: value }),
            });
            setUiSchemaMetaSchema(newMetaSchema);
            setJsonProps({ value: value, schema: schema, uiSchema: uiSchema });
        }
        catch (error) {
            console.error('Failed to parse schemas', error);
        }
    }, [uiSchema, schema, value]);
    var unfilteredExampleNames = getExampleNames(examples);
    var exampleNames = searchTermRegExp.source
        ? filter_1.default(unfilteredExampleNames, function (name) { return searchTermRegExp.test(name); })
        : unfilteredExampleNames;
    return (React.createElement(Flex_1.Flex, __assign({ p: 3 }, props),
        React.createElement(Flex_1.Flex, { flex: "1 1 50%", minWidth: 0, flexDirection: "column", pr: 2 },
            React.createElement(Flex_1.Flex, { mb: 3, alignItems: "center", justifyContent: "space-between" },
                React.createElement(Heading_1.default.h3, null, title),
                React.createElement(Flex_1.Flex, { ml: 3, alignItems: "center", justifyContent: "flex-end", flex: 1 },
                    React.createElement(Box_1.Box, { flex: 1 },
                        React.createElement(Select_1.default, { placeholder: "Load an example...", emptySearchMessage: "No results", searchPlaceholder: "Search...", onSearch: function (s) {
                                return setSearchTermRegExp(new RegExp(escapeRegExp_1.default(s), 'i'));
                            }, value: selectedExample, options: exampleNames, onChange: function (_a) {
                                var option = _a.option;
                                setSelectedExample(option);
                            } })),
                    React.createElement(Button_1.default, { ml: 2, tooltip: { text: 'Reset', placement: 'right' }, icon: React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faUndo_1.faUndo }), onClick: reset }))),
            React.createElement(EditCard, __assign({ flex: 1 }, commonCardProps),
                React.createElement(JsonEditor_1.default, { title: "Data", value: valueStr, onChange: setValueStr, schema: schema, isValid: isValueJsonValid }),
                React.createElement(JsonEditor_1.default, { title: "Schema", value: schemaStr, onChange: setSchemaStr, schema: json_schema_draft_07_json_1.default, isValid: isSchemaJsonValid }),
                React.createElement(JsonEditor_1.default, { title: "UI Schema", value: uiSchemaStr, onChange: setUiSchemaStr, schema: uiSchemaMetaSchema, isValid: isUiSchemaJsonValid }))),
        React.createElement(Flex_1.Flex, { flex: "1 1 50%", minWidth: 0, flexDirection: "column", pl: 2 },
            React.createElement(ResultCard, __assign({ flex: 1 }, commonCardProps, { title: "Result", cta: React.createElement(Checkbox_1.default, { checked: validate, label: "Validate", onChange: function (e) { return setValidate(e.target.checked); } }) }),
                React.createElement(index_1.default, __assign({}, jsonProps, { p: 2, pb: 1, validate: validate, backgroundColor: "#fff", extraFormats: EXTRA_FORMATS, extraContext: __assign(__assign({}, examples_1.CONTEXT_FUNCTIONS), { root: jsonProps.value }) }))))));
};
exports.default = asRendition_1.default(JsonSchemaRendererPlayground);
var templateObject_1, templateObject_2, templateObject_3;
