import * as React from 'react';
import { DefaultProps, RenditionSystemProps, Theme } from '../../common-types';
import { Value, JSONSchema, UiSchema, Format } from './types';
export declare const getValue: (value?: string | number | boolean | any[] | {
    [key: string]: any;
} | null | undefined, uiSchema?: UiSchema | undefined) => string | number | boolean | any[] | {
    [key: string]: any;
} | null | undefined;
export declare const getType: (value?: string | number | boolean | any[] | {
    [key: string]: any;
} | null | undefined) => "string" | "number" | "bigint" | "boolean" | "symbol" | "undefined" | "object" | "function" | "default" | "array" | "null";
export declare const getWidget: (value?: string | number | boolean | any[] | {
    [key: string]: any;
} | null | undefined, uiSchemaWidget?: UiSchema['ui:widget']) => import("./widgets/widget-util").Widget;
export declare const JsonSchemaRenderer: ({ value, schema, uiSchema, valueKey, extraFormats, extraContext, validate, nested, ...props }: ThemedJsonSchemaRendererProps) => JSX.Element | null;
interface ThemedJsonSchemaRendererProps extends InternalJsonSchemaRendererProps {
    theme: Theme;
}
interface InternalJsonSchemaRendererProps extends DefaultProps {
    nested?: boolean;
    validate?: boolean;
    valueKey?: string;
    value?: Value;
    schema: JSONSchema;
    uiSchema?: UiSchema;
    extraFormats?: Format[];
    extraContext?: object;
}
export declare type JsonSchemaRendererProps = InternalJsonSchemaRendererProps & RenditionSystemProps;
export declare const RenditionJsonSchemaRenderer: React.FunctionComponent<JsonSchemaRendererProps>;
export default function (props: JsonSchemaRendererProps): JSX.Element;
export {};
