"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RenditionJsonSchemaRenderer = exports.JsonSchemaRenderer = exports.getWidget = exports.getType = exports.getValue = void 0;
var React = __importStar(require("react"));
var forEach_1 = __importDefault(require("lodash/forEach"));
var keys_1 = __importDefault(require("lodash/keys"));
var pick_1 = __importDefault(require("lodash/pick"));
var get_1 = __importDefault(require("lodash/get"));
var isArray_1 = __importDefault(require("lodash/isArray"));
var ajv_1 = __importDefault(require("ajv"));
var asRendition_1 = __importDefault(require("../../asRendition"));
var Flex_1 = require("../../components/Flex");
var Alert_1 = __importDefault(require("../../components/Alert"));
var ErrorBoundary_1 = __importDefault(require("../../internal/ErrorBoundary"));
var widgets_1 = __importStar(require("./widgets"));
var widget_util_1 = require("./widgets/widget-util");
exports.getValue = function (value, uiSchema) {
    return get_1.default(uiSchema, 'ui:value', value);
};
var widgetWrapperUiOptionKeys = keys_1.default(widgets_1.WidgetWrapperUiOptions);
exports.getType = function (value) {
    if (value === undefined) {
        return 'default';
    }
    if (value === null) {
        return 'null';
    }
    return isArray_1.default(value) ? 'array' : typeof value;
};
exports.getWidget = function (value, uiSchemaWidget) {
    if (uiSchemaWidget && typeof uiSchemaWidget !== 'string') {
        return uiSchemaWidget;
    }
    var typeWidgets = get_1.default(widgets_1.default, exports.getType(value), widgets_1.default.default);
    return get_1.default(typeWidgets, uiSchemaWidget || 'default', typeWidgets.default);
};
var buildValidation = function (schema, extraFormats) {
    var validator = new ajv_1.default();
    forEach_1.default(extraFormats, function (_a) {
        var name = _a.name, format = _a.format;
        validator.addFormat(name, format);
    });
    return {
        validator: validator,
        validate: validator.compile(schema || {}),
    };
};
exports.JsonSchemaRenderer = function (_a) {
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema, valueKey = _a.valueKey, extraFormats = _a.extraFormats, extraContext = _a.extraContext, validate = _a.validate, nested = _a.nested, props = __rest(_a, ["value", "schema", "uiSchema", "valueKey", "extraFormats", "extraContext", "validate", "nested"]);
    var _b = React.useState(validate && !nested ? buildValidation(schema, extraFormats) : null), validation = _b[0], setValidation = _b[1];
    var _c = React.useState(null), validationErrors = _c[0], setValidationErrors = _c[1];
    React.useEffect(function () {
        if (!validate || nested) {
            setValidationErrors(null);
            return;
        }
        setValidation(buildValidation(schema, extraFormats));
    }, [validate, nested, extraFormats, schema]);
    React.useEffect(function () {
        if (!validate || nested) {
            return;
        }
        var v = validation;
        if (!v) {
            v = buildValidation(schema, extraFormats);
            setValidation(v);
        }
        v.validate(value);
        setValidationErrors(v.validate.errors);
    }, [validate, nested, validation, value]);
    if (uiSchema === null) {
        return null;
    }
    var processedUiSchema = widget_util_1.transformUiSchema({
        value: value,
        uiSchema: uiSchema,
        extraContext: extraContext,
    });
    var processedValue = exports.getValue(value, processedUiSchema);
    if (processedValue === undefined || processedValue === null) {
        return null;
    }
    var wrapperProps = pick_1.default.apply(void 0, __spreadArrays([get_1.default(processedUiSchema, 'ui:options', {})], widgetWrapperUiOptionKeys));
    var Widget = exports.getWidget(processedValue, processedUiSchema['ui:widget']);
    return (React.createElement(Flex_1.Flex, __assign({ minWidth: 0, minHeight: 0, alignItems: "flex-start", mb: 1, flexDirection: "column" }, props, wrapperProps),
        validationErrors && (React.createElement(Alert_1.default, { my: 2, plaintext: true, danger: true, tooltip: validation === null || validation === void 0 ? void 0 : validation.validator.errorsText(validationErrors) }, "Invalid data/schema")),
        React.createElement(widgets_1.WidgetMeta, { schema: schema, uiSchema: processedUiSchema, valueKey: valueKey }),
        React.createElement(Widget, { extraContext: extraContext, value: processedValue, schema: schema, uiSchema: processedUiSchema })));
};
exports.RenditionJsonSchemaRenderer = asRendition_1.default(exports.JsonSchemaRenderer);
function default_1(props) {
    return (React.createElement(ErrorBoundary_1.default, null,
        React.createElement(exports.RenditionJsonSchemaRenderer, __assign({}, props))));
}
exports.default = default_1;
