"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var get_1 = __importDefault(require("lodash/get"));
var invokeMap_1 = __importDefault(require("lodash/invokeMap"));
var isArray_1 = __importDefault(require("lodash/isArray"));
var styled_components_1 = __importDefault(require("styled-components"));
var Txt_1 = __importDefault(require("../../../components/Txt"));
var types_1 = require("../types");
var ui_options_1 = require("./ui-options");
var SingleLineTxt = styled_components_1.default(Txt_1.default)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\twhite-space: nowrap;\n\toverflow: hidden;\n\ttext-overflow: ellipsis;\n\tmax-width: 100%;\n"], ["\n\twhite-space: nowrap;\n\toverflow: hidden;\n\ttext-overflow: ellipsis;\n\tmax-width: 100%;\n"])));
var getArrayValue = function (value, uiSchema) {
    var maxItems = get_1.default(uiSchema, ['ui:options', 'truncate'], value.length);
    var arrayString = invokeMap_1.default(value.slice(0, maxItems), 'toString').join(', ');
    if (maxItems < value.length) {
        arrayString += " and " + (value.length - maxItems) + " more...";
    }
    return arrayString;
};
var TxtWidget = function (_a) {
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema, props = __rest(_a, ["value", "schema", "uiSchema"]);
    var displayValue = isArray_1.default(value)
        ? getArrayValue(value, uiSchema)
        : value === null || value === void 0 ? void 0 : value.toString();
    var Component = get_1.default(uiSchema, ['ui:options', 'truncate'])
        ? SingleLineTxt
        : Txt_1.default;
    return React.createElement(Component, __assign({}, props), displayValue || '');
};
TxtWidget.uiOptions = {
    bold: ui_options_1.UiOption.boolean,
    italic: ui_options_1.UiOption.boolean,
    monospace: ui_options_1.UiOption.boolean,
    caps: ui_options_1.UiOption.boolean,
    align: __assign(__assign({}, ui_options_1.UiOption.string), { enum: [
            'left',
            'right',
            'center',
            'justify',
            'justify-all',
            'start',
            'end',
            'match-parent',
            'inherit',
            'initial',
            'unset',
        ] }),
    whitespace: __assign(__assign({}, ui_options_1.UiOption.string), { enum: [
            'normal',
            'nowrap',
            'pre',
            'pre-line',
            'pre-wrap',
            'initial',
            'inherit',
        ] }),
};
TxtWidget.supportedTypes = [
    types_1.JsonTypes.string,
    types_1.JsonTypes.null,
    types_1.JsonTypes.integer,
    types_1.JsonTypes.number,
    types_1.JsonTypes.boolean,
    types_1.JsonTypes.array,
];
exports.default = TxtWidget;
var templateObject_1;
