"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var values_1 = __importDefault(require("lodash/values"));
var ArrayWidget_1 = __importDefault(require("./ArrayWidget"));
var BadgeWidget_1 = __importDefault(require("./BadgeWidget"));
var ButtonGroupWidget_1 = __importDefault(require("./ButtonGroupWidget"));
var ButtonWidget_1 = __importDefault(require("./ButtonWidget"));
var CheckboxWidget_1 = __importDefault(require("./CheckboxWidget"));
var DropDownButtonWidget_1 = __importDefault(require("./DropDownButtonWidget"));
var HeadingWidget_1 = __importDefault(require("./HeadingWidget"));
var HighlightedNameWidget_1 = __importDefault(require("./HighlightedNameWidget"));
var ImgWidget_1 = __importDefault(require("./ImgWidget"));
var LinkWidget_1 = __importDefault(require("./LinkWidget"));
var ListWidget_1 = __importDefault(require("./ListWidget"));
var MarkdownWidget_1 = __importDefault(require("./MarkdownWidget"));
var ObjectWidget_1 = __importDefault(require("./ObjectWidget"));
var TagWidget_1 = __importDefault(require("./TagWidget"));
var TxtWidget_1 = __importDefault(require("./TxtWidget"));
var types_1 = require("../types");
var widget_util_1 = require("./widget-util");
var ui_options_1 = require("./ui-options");
Object.defineProperty(exports, "WidgetWrapperUiOptions", { enumerable: true, get: function () { return ui_options_1.WidgetWrapperUiOptions; } });
var widget_util_2 = require("./widget-util");
Object.defineProperty(exports, "getObjectPropertyNames", { enumerable: true, get: function () { return widget_util_2.getObjectPropertyNames; } });
var WidgetMeta_1 = require("./WidgetMeta");
Object.defineProperty(exports, "WidgetMeta", { enumerable: true, get: function () { return WidgetMeta_1.default; } });
var widgets = {};
values_1.default(types_1.JsonTypes).reduce(function (acc, jsonType) {
    acc[jsonType] = {};
    return acc;
}, widgets);
var allWidgets = {};
[
    ArrayWidget_1.default,
    BadgeWidget_1.default,
    ButtonGroupWidget_1.default,
    ButtonWidget_1.default,
    CheckboxWidget_1.default,
    DropDownButtonWidget_1.default,
    HeadingWidget_1.default,
    HighlightedNameWidget_1.default,
    ImgWidget_1.default,
    LinkWidget_1.default,
    ListWidget_1.default,
    MarkdownWidget_1.default,
    ObjectWidget_1.default,
    TagWidget_1.default,
    TxtWidget_1.default,
].reduce(function (acc, widget) {
    var widgetName = widget.name.replace(/Widget$/, '');
    var wrappedWidget = widget.uiOptions
        ? widget_util_1.withOptionProps(widget.uiOptions)(widget)
        : widget;
    acc[widgetName] = wrappedWidget;
    if (widget.supportedTypes) {
        widget.supportedTypes.forEach(function (jsonType) {
            widgets[jsonType][widgetName] = wrappedWidget;
        });
    }
    return acc;
}, allWidgets);
widgets.object.default = allWidgets.Object;
widgets.string.default = allWidgets.Txt;
widgets.null.default = allWidgets.Txt;
widgets.integer.default = allWidgets.Txt;
widgets.number.default = allWidgets.Txt;
widgets.boolean.default = allWidgets.Checkbox;
widgets.array.default = allWidgets.Array;
widgets.default = {
    default: allWidgets.Txt,
};
exports.default = widgets;
