"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getObjectPropertyNames = exports.getArrayItems = exports.transformUiSchema = exports.withOptionProps = void 0;
var React = __importStar(require("react"));
var json_e_1 = __importDefault(require("json-e"));
var merge_1 = __importDefault(require("lodash/merge"));
var pickBy_1 = __importDefault(require("lodash/pickBy"));
var difference_1 = __importDefault(require("lodash/difference"));
var isArray_1 = __importDefault(require("lodash/isArray"));
var keys_1 = __importDefault(require("lodash/keys"));
var concat_1 = __importDefault(require("lodash/concat"));
var get_1 = __importDefault(require("lodash/get"));
var pick_1 = __importDefault(require("lodash/pick"));
function withOptionProps(uiOptions) {
    return function (Component) {
        var wrapped = function (props) {
            var extraProps = pick_1.default.apply(void 0, __spreadArrays([get_1.default(props.uiSchema, 'ui:options', {})], keys_1.default(uiOptions)));
            return React.createElement(Component, __assign({}, props, extraProps));
        };
        wrapped.uiOptions = Component.uiOptions;
        wrapped.supportedTypes = Component.supportedTypes;
        return wrapped;
    };
}
exports.withOptionProps = withOptionProps;
exports.transformUiSchema = function (_a) {
    var value = _a.value, uiSchema = _a.uiSchema, extraContext = _a.extraContext;
    var context = __assign({ source: value }, extraContext);
    if (typeof value === 'object') {
        var trimmedUiSchema = pickBy_1.default(uiSchema || {}, function (_, k) {
            return k.startsWith('ui:');
        });
        var processedUiSchema = json_e_1.default(trimmedUiSchema, context);
        return merge_1.default({}, uiSchema, processedUiSchema);
    }
    return json_e_1.default(uiSchema || {}, context);
};
exports.getArrayItems = function (_a) {
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema, extraContext = _a.extraContext;
    if (!isArray_1.default(value)) {
        throw new Error("Value must be an array (not '" + typeof value + "')");
    }
    var maxItems = get_1.default(uiSchema, ['ui:options', 'truncate'], value.length);
    var items = value.slice(0, maxItems).map(function (item) {
        var itemSchema = get_1.default(schema, 'items', {});
        var itemUiSchema = get_1.default(uiSchema, 'items', {});
        var processedUiSchema = exports.transformUiSchema({
            value: item,
            uiSchema: itemUiSchema,
            extraContext: extraContext,
        });
        return {
            value: item,
            schema: itemSchema,
            uiSchema: processedUiSchema,
            extraContext: extraContext,
        };
    });
    if (maxItems < value.length) {
        items.push({
            value: "+ " + (value.length - maxItems) + " more",
            schema: {
                type: 'string',
            },
            uiSchema: {},
            extraContext: extraContext,
        });
    }
    return items;
};
var getMaterializedPropertyNames = function (uiSchema) {
    return keys_1.default(uiSchema).filter(function (uiSchemaKey) {
        return uiSchemaKey.startsWith('ui:field:');
    });
};
function getObjectPropertyNames(_a) {
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema;
    if (typeof value !== 'object') {
        throw new Error("Cannot get object property names from a value of type '" + typeof value + "'");
    }
    var uiSchemaPropertyNames = getMaterializedPropertyNames(uiSchema);
    var schemaPropertyNames = get_1.default(uiSchema, ['ui:order'], keys_1.default(get_1.default(schema, 'properties'))) || [];
    var nonSchemaPropertyNames = difference_1.default(keys_1.default(value) || [], schemaPropertyNames);
    return concat_1.default(uiSchemaPropertyNames, schemaPropertyNames, nonSchemaPropertyNames);
}
exports.getObjectPropertyNames = getObjectPropertyNames;
