"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Markdown = exports.MarkdownBase = exports.getProcessor = exports.defaultSanitizerOptions = void 0;
var React = __importStar(require("react"));
var Txt_1 = __importDefault(require("../../components/Txt"));
var Heading_1 = __importDefault(require("../../components/Heading"));
var Link_1 = __importDefault(require("../../components/Link"));
var unified_1 = __importDefault(require("unified"));
var remark_parse_1 = __importDefault(require("remark-parse"));
var remark_rehype_1 = __importDefault(require("remark-rehype"));
var rehype_react_1 = __importDefault(require("rehype-react"));
var rehype_sanitize_1 = __importDefault(require("rehype-sanitize"));
var rehype_raw_1 = __importDefault(require("rehype-raw"));
var rehype_prism_1 = __importDefault(require("@mapbox/rehype-prism"));
var Divider_1 = __importDefault(require("../../components/Divider"));
var styled_components_1 = __importStar(require("styled-components"));
var github_json_1 = __importDefault(require("hast-util-sanitize/lib/github.json"));
exports.defaultSanitizerOptions = github_json_1.default;
require("prismjs/themes/prism.css");
var utils_1 = require("../../utils");
var MarkdownWrapper = styled_components_1.default(Txt_1.default)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t* {\n\t\tbox-sizing: border-box;\n\t}\n\n\t& code {\n\t\tbackground-color: ", ";\n\t\tpadding: 0.2em 0px;\n\t\tmargin: 0px;\n\t\tborder-radius: 3px;\n\t\tline-height: 1.2;\n\t}\n\n\t& pre {\n\t\tbackground-color: ", ";\n\t}\n\n\t& pre > code {\n\t\tbackground: none;\n\t}\n\n\t& code,\n\tkbd,\n\tpre {\n\t\tfont-family: ", ";\n\t}\n\n\t& kbd {\n\t\tdisplay: inline-block;\n\t\tpadding: 3px 5px;\n\t\tfont-size: 11px;\n\t\tline-height: 10px;\n\t\tcolor: ", ";\n\t\tvertical-align: middle;\n\t\tbackground-color: ", ";\n\t\tborder: solid 1px ", ";\n\t\tborder-bottom-color: ", ";\n\t\tborder-radius: 3px;\n\t\tbox-shadow: inset 0 -1px 0 ", ";\n\t}\n\n\tdl {\n\t\tpadding: 0;\n\t}\n\n\tdl dt {\n\t\tpadding: 0;\n\t\tmargin-top: 16px;\n\t\tfont-size: 1em;\n\t\tfont-style: italic;\n\t\tfont-weight: ", ";\n\t}\n\n\tdl dd {\n\t\tpadding: 0 16px;\n\t\tmargin-bottom: 16px;\n\t}\n\n\ttd,\n\tth {\n\t\tpadding: 0;\n\t}\n\n\ttable {\n\t\tborder-spacing: 0;\n\t\tborder-collapse: collapse;\n\t\tdisplay: block;\n\t\twidth: 100%;\n\t\toverflow: auto;\n\t}\n\n\ttable th {\n\t\tfont-weight: ", ";\n\t}\n\n\ttable th,\n\ttable td {\n\t\tpadding: 6px 13px;\n\t\tborder: 1px solid ", ";\n\t}\n\n\ttable tr {\n\t\tbackground-color: #fff;\n\t\tborder-top: 1px solid ", ";\n\t}\n\n\ttable tr:nth-child(2n) {\n\t\tbackground-color: ", ";\n\t}\n\n\tblockquote {\n\t\tmargin: 0;\n\t}\n\n\tblockquote,\n\tdl,\n\ttable {\n\t\tmargin-top: 0;\n\t\tmargin-bottom: 16px;\n\t}\n\n\tblockquote {\n\t\tpadding: 0 1em;\n\t\tcolor: ", ";\n\t\tborder-left: 0.25em solid ", ";\n\t}\n\n\tblockquote > :first-child {\n\t\tmargin-top: 0;\n\t}\n\n\tblockquote > :last-child {\n\t\tmargin-bottom: 0;\n\t}\n"], ["\n\t* {\n\t\tbox-sizing: border-box;\n\t}\n\n\t& code {\n\t\tbackground-color: ", ";\n\t\tpadding: 0.2em 0px;\n\t\tmargin: 0px;\n\t\tborder-radius: 3px;\n\t\tline-height: 1.2;\n\t}\n\n\t& pre {\n\t\tbackground-color: ", ";\n\t}\n\n\t& pre > code {\n\t\tbackground: none;\n\t}\n\n\t& code,\n\tkbd,\n\tpre {\n\t\tfont-family: ", ";\n\t}\n\n\t& kbd {\n\t\tdisplay: inline-block;\n\t\tpadding: 3px 5px;\n\t\tfont-size: 11px;\n\t\tline-height: 10px;\n\t\tcolor: ", ";\n\t\tvertical-align: middle;\n\t\tbackground-color: ", ";\n\t\tborder: solid 1px ", ";\n\t\tborder-bottom-color: ",
    ";\n\t\tborder-radius: 3px;\n\t\tbox-shadow: inset 0 -1px 0 ", ";\n\t}\n\n\tdl {\n\t\tpadding: 0;\n\t}\n\n\tdl dt {\n\t\tpadding: 0;\n\t\tmargin-top: 16px;\n\t\tfont-size: 1em;\n\t\tfont-style: italic;\n\t\tfont-weight: ", ";\n\t}\n\n\tdl dd {\n\t\tpadding: 0 16px;\n\t\tmargin-bottom: 16px;\n\t}\n\n\ttd,\n\tth {\n\t\tpadding: 0;\n\t}\n\n\ttable {\n\t\tborder-spacing: 0;\n\t\tborder-collapse: collapse;\n\t\tdisplay: block;\n\t\twidth: 100%;\n\t\toverflow: auto;\n\t}\n\n\ttable th {\n\t\tfont-weight: ", ";\n\t}\n\n\ttable th,\n\ttable td {\n\t\tpadding: 6px 13px;\n\t\tborder: 1px solid ", ";\n\t}\n\n\ttable tr {\n\t\tbackground-color: #fff;\n\t\tborder-top: 1px solid ", ";\n\t}\n\n\ttable tr:nth-child(2n) {\n\t\tbackground-color: ", ";\n\t}\n\n\tblockquote {\n\t\tmargin: 0;\n\t}\n\n\tblockquote,\n\tdl,\n\ttable {\n\t\tmargin-top: 0;\n\t\tmargin-bottom: 16px;\n\t}\n\n\tblockquote {\n\t\tpadding: 0 1em;\n\t\tcolor: ", ";\n\t\tborder-left: 0.25em solid ", ";\n\t}\n\n\tblockquote > :first-child {\n\t\tmargin-top: 0;\n\t}\n\n\tblockquote > :last-child {\n\t\tmargin-bottom: 0;\n\t}\n"])), function (props) { return props.theme.colors.gray.light; }, function (props) { return props.theme.colors.gray.light; }, function (props) { return props.theme.monospace; }, function (props) { return props.theme.colors.text.main; }, function (props) { return utils_1.lighten(props.theme.colors.gray.light); }, function (props) { return props.theme.colors.gray.main; }, function (props) {
    return utils_1.darken(props.theme.colors.gray.main, 0.1);
}, function (props) { return utils_1.darken(props.theme.colors.gray.main, 0.1); }, function (props) { return props.theme.weights[1]; }, function (props) { return props.theme.weights[1]; }, function (props) { return props.theme.colors.gray.main; }, function (props) { return props.theme.colors.gray.light; }, function (props) { return props.theme.colors.gray.light; }, function (props) { return props.theme.colors.text.main; }, function (props) { return props.theme.colors.gray.main; });
exports.getProcessor = function (componentOverrides, sanitizerOptions, disableRawHtml, disableCodeHighlight) {
    var processor = unified_1.default()
        .use(remark_parse_1.default, { gfm: true })
        .use(remark_rehype_1.default, { allowDangerousHtml: !disableRawHtml });
    if (!disableCodeHighlight) {
        processor = processor.use(rehype_prism_1.default);
    }
    if (!disableRawHtml) {
        processor = processor.use(rehype_raw_1.default);
    }
    if (sanitizerOptions !== null) {
        processor = processor.use(rehype_sanitize_1.default, sanitizerOptions !== null && sanitizerOptions !== void 0 ? sanitizerOptions : __assign(__assign({}, github_json_1.default), { attributes: __assign(__assign({}, github_json_1.default.attributes), { '*': __spreadArrays(github_json_1.default.attributes['*'], ['class', 'className']) }) }));
    }
    return processor.use(rehype_react_1.default, {
        createElement: React.createElement,
        components: __assign({ p: function (props) { return React.createElement(Txt_1.default.p, __assign({}, props)); }, a: function (props) { return React.createElement(Link_1.default, __assign({}, props)); }, h1: function (props) { return React.createElement(Heading_1.default.h1, __assign({}, props)); }, h2: function (props) { return React.createElement(Heading_1.default.h2, __assign({}, props)); }, h3: function (props) { return React.createElement(Heading_1.default.h3, __assign({}, props)); }, h4: function (props) { return React.createElement(Heading_1.default.h4, __assign({}, props)); }, h5: function (props) { return React.createElement(Heading_1.default.h5, __assign({}, props)); }, h6: function (props) { return React.createElement(Heading_1.default.h6, __assign({}, props)); }, hr: function (props) { return React.createElement(Divider_1.default, __assign({}, props)); } }, componentOverrides),
    });
};
exports.MarkdownBase = function (_a) {
    var children = _a.children, componentOverrides = _a.componentOverrides, sanitizerOptions = _a.sanitizerOptions, disableRawHtml = _a.disableRawHtml, disableCodeHighlight = _a.disableCodeHighlight, props = __rest(_a, ["children", "componentOverrides", "sanitizerOptions", "disableRawHtml", "disableCodeHighlight"]);
    return (React.createElement(MarkdownWrapper, __assign({}, props), exports.getProcessor(componentOverrides, sanitizerOptions, disableRawHtml, disableCodeHighlight).processSync(children).result));
};
exports.Markdown = styled_components_1.withTheme(exports.MarkdownBase);
var templateObject_1;
