"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DismissableContainer = void 0;
var faTimes_1 = require("@fortawesome/free-solid-svg-icons/faTimes");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var react_1 = __importDefault(require("react"));
var styled_components_1 = __importStar(require("styled-components"));
var Button_1 = __importDefault(require("../../components/Button"));
var Flex_1 = require("../../components/Flex");
var utils_1 = require("../../utils");
var ICON_SIZE = 14;
var Wrapper = styled_components_1.default(Flex_1.Flex)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tposition: relative;\n\tmargin: 0;\n\tpadding: ", ";\n\tpadding-right: ", ";\n\tbox-shadow: 0 0 10px 0\n\t\t", ";\n\tborder-radius: 10px;\n\tborder: 1px solid\n\t\t", ";\n\tbackground-color: ", ";\n\tcolor: ", ";\n"], ["\n\tposition: relative;\n\tmargin: 0;\n\tpadding: ", ";\n\tpadding-right: ",
    ";\n\tbox-shadow: 0 0 10px 0\n\t\t", ";\n\tborder-radius: 10px;\n\tborder: 1px solid\n\t\t",
    ";\n\tbackground-color: ",
    ";\n\tcolor: ",
    ";\n"])), function (props) { return utils_1.px(props.theme.space[3]); }, function (props) {
    return utils_1.px(props.hasDismissButton ? props.theme.space[4] : props.theme.space[3]);
}, function (props) { return utils_1.opaque(props.theme.colors.quartenary.main, 0.15); }, function (props) {
    return props.bordered
        ? props.solid
            ? utils_1.getColor(props, 'bg', 'main')
            : props.theme.colors.quartenary.main
        : 'transparent';
}, function (props) {
    return props.solid ? utils_1.getColor(props, 'bg', 'light') : 'white';
}, function (props) {
    return props.solid ? utils_1.getColor(props, 'bg', 'dark') : props.color || 'inherit';
});
var DismissButton = styled_components_1.default(Button_1.default)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tposition: absolute;\n\t& svg {\n\t\theight: ", ";\n\t\twidth: ", ";\n\t}\n\tfont-size: ", ";\n\tpadding: ", "; /* give more clickable surface area */\n\ttop: ", ";\n\tright: ", ";\n\ttransform: translate(0, -50%);\n"], ["\n\tposition: absolute;\n\t& svg {\n\t\theight: ", ";\n\t\twidth: ", ";\n\t}\n\tfont-size: ", ";\n\tpadding: ",
    "; /* give more clickable surface area */\n\ttop: ", ";\n\tright: ", ";\n\ttransform: translate(0, -50%);\n"])), utils_1.px(ICON_SIZE), utils_1.px(ICON_SIZE), utils_1.px(ICON_SIZE), function (props) {
    return utils_1.px(props.theme.space[2]);
}, function (props) { return utils_1.px(props.theme.space[3] + props.baselineHeight / 2); }, function (props) { return utils_1.px(props.theme.space[3] - props.theme.space[2]); });
exports.DismissableContainer = styled_components_1.withTheme(react_1.default.forwardRef(function (_a, ref) {
    var children = _a.children, onDismiss = _a.onDismiss, baselineHeight = _a.baselineHeight, solid = _a.solid, theme = _a.theme, a11yTitle = _a.a11yTitle, bordered = _a.bordered, restProps = __rest(_a, ["children", "onDismiss", "baselineHeight", "solid", "theme", "a11yTitle", "bordered"]);
    var baseline = baselineHeight || theme.fontSizes[2] * theme.lineHeight;
    return (react_1.default.createElement(Wrapper, __assign({ solid: solid, bordered: bordered, hasDismissButton: Boolean(onDismiss), ref: ref }, restProps),
        children,
        onDismiss && (react_1.default.createElement(DismissButton, { title: a11yTitle || 'Dismiss', a11yTitle: a11yTitle || 'Dismiss', baselineHeight: baseline, color: solid
                ? utils_1.getColor(__assign({ theme: theme }, restProps), 'bg', 'dark')
                : undefined, primary: !solid, plain: true, onClick: onDismiss },
            react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faTimes_1.faTimes })))));
}));
exports.DismissableContainer.defaultProps = {
    bordered: true,
};
var templateObject_1, templateObject_2;
