import { __assign } from "tslib";
import { faMinus } from '@fortawesome/free-solid-svg-icons/faMinus';
import { faPlus } from '@fortawesome/free-solid-svg-icons/faPlus';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { Accordion as GrommetAccordion, AccordionPanel as GrommetAccordionPanel, } from 'grommet';
import * as React from 'react';
import asRendition from '../../asRendition';
import { getColor } from '../../utils';
import { Box } from '../Box';
import { Flex } from '../Flex';
import Txt from '../Txt';
var Accordion = function (props) {
    var _a = React.useState([]), openPanels = _a[0], setOpenPanels = _a[1];
    var items = props.items;
    return (React.createElement(GrommetAccordion, { activeIndex: openPanels, onActive: function (opens) { return setOpenPanels(opens); } }, items.map(function (item, index) { return (React.createElement(GrommetAccordionPanel, { header: React.createElement(Flex, { alignItems: "center", justifyContent: "space-between" },
            React.createElement(Flex, { px: 16 },
                React.createElement(Txt, { my: 24, fontSize: 16, bold: true }, item.label)),
            React.createElement(Flex, { alignItems: "center", justifyContent: "flex-end", pr: 16 },
                React.createElement(FontAwesomeIcon, { color: getColor(__assign(__assign({}, props), { gray: true }), 'color', 'main'), icon: openPanels.includes(index) ? faMinus : faPlus }))) },
        React.createElement(Box, { px: 16, mt: 10, mb: 24 }, item.panel))); })));
};
export default asRendition(Accordion, []);
