import { __assign, __rest } from "tslib";
import * as React from 'react';
import { Avatar as GrommetAvatar, } from 'grommet';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { faUserCircle } from '@fortawesome/free-solid-svg-icons/faUserCircle';
import { Txt } from '../../';
import { withTheme } from 'styled-components';
import { px } from 'styled-system';
var getInitials = function (firstName, lastName) {
    return "" + ((firstName === null || firstName === void 0 ? void 0 : firstName.charAt(0).toUpperCase()) || '') + ((lastName === null || lastName === void 0 ? void 0 : lastName.charAt(0).toUpperCase()) || '');
};
var AvatarBase = function (_a) {
    var theme = _a.theme, src = _a.src, firstName = _a.firstName, lastName = _a.lastName, emphasized = _a.emphasized, otherProps = __rest(_a, ["theme", "src", "firstName", "lastName", "emphasized"]);
    var initials = getInitials(firstName, lastName);
    return (React.createElement(React.Fragment, null,
        src && (React.createElement(GrommetAvatar, __assign({ size: emphasized ? px(theme.fontSizes[6]) : px(theme.fontSizes[5]), src: src, background: theme.colors.quartenary.dark }, otherProps))),
        initials && !src && (React.createElement(GrommetAvatar, __assign({ background: theme.colors.quartenary.dark, size: emphasized ? px(theme.fontSizes[6]) : px(theme.fontSizes[5]) }, otherProps),
            React.createElement(Txt, { color: 'white' }, initials))),
        !initials && !src && (React.createElement(GrommetAvatar, __assign({ background: theme.colors.quartenary.dark, size: emphasized ? px(theme.fontSizes[6]) : px(theme.fontSizes[5]) }, otherProps),
            React.createElement(FontAwesomeIcon, { style: {
                    color: theme.colors.quartenary.dark,
                    background: 'white',
                }, size: emphasized ? '3x' : '2x', icon: faUserCircle })))));
};
export var Avatar = withTheme(AvatarBase);
