import { __assign, __makeTemplateObject, __rest } from "tslib";
import { Button } from 'grommet';
import * as React from 'react';
import styled, { css } from 'styled-components';
import asRendition from '../../asRendition';
import { useBreakpoint } from '../../hooks/useBreakpoint';
import { getColor, getColoringType, isLight, px } from '../../utils';
var getHoverEffectOverride = function (bg, color, opacity) {
    return css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t\t&:hover:enabled,\n\t\t&:focus:enabled,\n\t\t&:active:enabled {\n\t\t\tsvg {\n\t\t\t\tcolor: ", " !important;\n\t\t\t}\n\n\t\t\tbox-shadow: none;\n\t\t\tbackground: ", ";\n\t\t\tborder-color: ", ";\n\t\t\tcolor: ", ";\n\t\t\topacity: ", ";\n\t\t}\n\t"], ["\n\t\t&:hover:enabled,\n\t\t&:focus:enabled,\n\t\t&:active:enabled {\n\t\t\tsvg {\n\t\t\t\tcolor: ", " !important;\n\t\t\t}\n\n\t\t\tbox-shadow: none;\n\t\t\tbackground: ", ";\n\t\t\tborder-color: ", ";\n\t\t\tcolor: ", ";\n\t\t\topacity: ", ";\n\t\t}\n\t"])), color, bg, bg, color, opacity !== null && opacity !== void 0 ? opacity : 'initial');
};
var ButtonBase = styled(Button)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\t& {\n\t\tfont-weight: ", ";\n\t\tfont-size: ", ";\n\t\theight: ", ";\n\t\twhite-space: nowrap;\n\t\tsvg {\n\t\t\tcolor: inherit !important;\n\t\t\tfont-size: 0.925em;\n\t\t}\n\t\t/* These rules cause consistent styling when the button is rendered as a link */\n\t\tdisplay: inline-flex;\n\t\talign-items: center;\n\t\tjustify-content: center;\n\n\t\t&:disabled {\n\t\t\tcursor: not-allowed;\n\t\t}\n\t}\n"], ["\n\t& {\n\t\tfont-weight: ", ";\n\t\tfont-size: ", ";\n\t\theight: ", ";\n\t\twhite-space: nowrap;\n\t\tsvg {\n\t\t\tcolor: inherit !important;\n\t\t\tfont-size: 0.925em;\n\t\t}\n\t\t/* These rules cause consistent styling when the button is rendered as a link */\n\t\tdisplay: inline-flex;\n\t\talign-items: center;\n\t\tjustify-content: center;\n\n\t\t&:disabled {\n\t\t\tcursor: not-allowed;\n\t\t}\n\t}\n"])), function (props) { return props.theme.button.font.weight; }, function (props) { return props.theme.button.font.size; }, function (props) { return props.theme.button.height; });
var ColouredButton = styled(ButtonBase)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n\t& {\n\t\tcolor: ", ";\n\t\t", ";\n\t}\n"], ["\n\t& {\n\t\tcolor: ",
    ";\n\t\t",
    ";\n\t}\n"])), function (props) {
    return isLight(getColor(props, 'color', 'main'))
        ? props.theme.colors.text.main
        : 'white';
}, function (props) {
    var color = getColor(props, 'color', 'dark');
    return getHoverEffectOverride(color, isLight(color) ? props.theme.colors.text.main : 'white');
});
var Outline = styled(ButtonBase)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n\t& {\n\t\tcolor: ", ";\n\t\tborder-color: ", ";\n\t\tsvg {\n\t\t\tcolor: ", " !important;\n\t\t}\n\t\t", ";\n\t}\n"], ["\n\t& {\n\t\tcolor: ", ";\n\t\tborder-color: ",
    ";\n\t\tsvg {\n\t\t\tcolor: ", " !important;\n\t\t}\n\t\t",
    ";\n\t}\n"])), function (props) { return props.theme.colors.text.main; }, function (props) {
    return getColor(props, 'color', 'main') || props.theme.colors.text.main;
}, function (props) { return props.theme.colors.tertiary.main; }, function (props) {
    return getHoverEffectOverride(props.color || props.theme.colors.text.main, isLight(getColor(props, 'color', 'main'))
        ? props.theme.colors.text.main
        : 'white');
});
var Light = styled(ButtonBase)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n\t& {\n\t\tcolor: ", ";\n\t\tborder-color: ", ";\n\t\tbackground: white;\n\t\tborder: none;\n\t\t", ";\n\n\t\t&:disabled {\n\t\t\topacity: 1;\n\t\t\tcolor: #c6c8c9;\n\t\t}\n\t}\n"], ["\n\t& {\n\t\tcolor: ", ";\n\t\tborder-color: ", ";\n\t\tbackground: white;\n\t\tborder: none;\n\t\t",
    ";\n\n\t\t&:disabled {\n\t\t\topacity: 1;\n\t\t\tcolor: #c6c8c9;\n\t\t}\n\t}\n"])), function (props) { return props.theme.colors.text.main; }, function (props) { return props.theme.colors.text.main; }, function (props) {
    return getHoverEffectOverride('white', props.theme.colors.secondary.main, '0.9');
});
var LightOutline = styled(Light)(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n\t& {\n\t\tcolor: white;\n\t\tborder: 1px solid white;\n\t\tbackground: transparent;\n\t\t", ";\n\n\t\t&:disabled {\n\t\t\topacity: 1;\n\t\t\tcolor: #c6c8c9;\n\t\t}\n\t}\n"], ["\n\t& {\n\t\tcolor: white;\n\t\tborder: 1px solid white;\n\t\tbackground: transparent;\n\t\t",
    ";\n\n\t\t&:disabled {\n\t\t\topacity: 1;\n\t\t\tcolor: #c6c8c9;\n\t\t}\n\t}\n"])), function (props) {
    return getHoverEffectOverride('white', props.theme.colors.secondary.main, '0.9');
});
var Plain = styled(ButtonBase)(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n\t& {\n\t\tcolor: ", ";\n\t\theight: auto;\n\t\tfont-weight: ", ";\n\t\tborder-radius: 0;\n\t\t", ";\n\t}\n"], ["\n\t& {\n\t\tcolor: ",
    ";\n\t\theight: auto;\n\t\tfont-weight: ", ";\n\t\tborder-radius: 0;\n\t\t",
    ";\n\t}\n"])), function (props) {
    return getColor(props, 'color', 'main') || props.theme.colors.text.main;
}, function (props) { return props.theme.button.font.weight; }, function (props) {
    return getHoverEffectOverride('none', getColor(props, 'color', 'dark') || props.theme.colors.text.light);
});
var underlineButtonActiveStyles = function (props) { return css(templateObject_8 || (templateObject_8 = __makeTemplateObject(["\n\t& {\n\t\tcolor: ", ";\n\t\tbackground: none;\n\t\tbox-shadow: 0px -1px 0 0px inset;\n\t}\n"], ["\n\t& {\n\t\tcolor: ", ";\n\t\tbackground: none;\n\t\tbox-shadow: 0px -1px 0 0px inset;\n\t}\n"])), getColor(props, 'color', 'main') || props.theme.colors.text.main); };
var Underline = styled(Plain)(templateObject_9 || (templateObject_9 = __makeTemplateObject(["\n\t& {\n\t\t", "\n\t\tborder-bottom: 1px solid;\n\t\tbackground: none;\n\t\t&:hover:enabled,\n\t\t&:focus:enabled,\n\t\t&:active:enabled {\n\t\t\t", ";\n\t\t}\n\t}\n"], ["\n\t& {\n\t\t", "\n\t\tborder-bottom: 1px solid;\n\t\tbackground: none;\n\t\t&:hover:enabled,\n\t\t&:focus:enabled,\n\t\t&:active:enabled {\n\t\t\t", ";\n\t\t}\n\t}\n"])), function (props) { return (props.active ? underlineButtonActiveStyles(props) : ''); }, underlineButtonActiveStyles);
var getStyledButton = function (_a, isPrimary) {
    var outline = _a.outline, underline = _a.underline, plain = _a.plain, active = _a.active, light = _a.light;
    if (plain) {
        return Plain;
    }
    if (light) {
        if (outline) {
            return LightOutline;
        }
        return Light;
    }
    if (underline) {
        return Underline;
    }
    if ((outline && !active) || !isPrimary) {
        return Outline;
    }
    return ColouredButton;
};
var Base = function (props) {
    var outline = props.outline, underline = props.underline, children = props.children, label = props.label, primary = props.primary, color = props.color, plain = props.plain, active = props.active, light = props.light, compact = props.compact, restProps = __rest(props, ["outline", "underline", "children", "label", "primary", "color", "plain", "active", "light", "compact"]);
    var shouldCompact = useBreakpoint(compact || [false]);
    var basePrimary = !!props.bg ||
        (!!getColoringType(props) && !outline && !underline && !props.plain);
    var baseColor = props.bg || getColor(props, 'bg', 'main');
    baseColor = baseColor || props.theme.colors.secondary.main;
    if (active) {
        basePrimary = !basePrimary;
    }
    var StyledButton = getStyledButton({ underline: underline, plain: plain, active: active, light: light }, basePrimary);
    return (React.createElement(StyledButton, __assign({ primary: basePrimary, color: baseColor, active: active && (underline || plain), gap: px(props.theme.space[2]) }, restProps, { plain: !!plain || !!underline, label: shouldCompact ? undefined : label || children })));
};
export default asRendition(Base, [], ['width', 'color', 'bg']);
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8, templateObject_9;
