import { __assign, __rest } from "tslib";
import * as React from 'react';
import { randomString } from '../../utils';
import Select from '../Select';
import { getJsonDescription } from './utils';
export var operators = {
    is: {
        getLabel: function (_s) { return 'is'; },
    },
};
export var decodeFilter = function (filter) {
    if (!filter.properties) {
        return null;
    }
    var keys = Object.keys(filter.properties);
    if (!keys.length) {
        return null;
    }
    var field = keys[0];
    var operator = filter.title;
    var value;
    if (operator === 'is') {
        value = filter.properties[field].const;
    }
    else {
        return null;
    }
    return {
        field: field,
        operator: operator,
        value: value,
    };
};
export var createFilter = function (field, operator, value, schema) {
    var _a;
    var title = schema.title;
    var base = {
        $id: randomString(),
        title: operator,
        description: getJsonDescription(title || field, operators[operator].getLabel(schema), value),
        type: 'object',
    };
    if (operator === 'is') {
        return Object.assign(base, {
            properties: (_a = {},
                _a[field] = {
                    const: value,
                },
                _a),
            required: [field],
        });
    }
    return base;
};
export var Edit = function (_a) {
    var value = _a.value, onUpdate = _a.onUpdate, props = __rest(_a, ["value", "onUpdate"]);
    return (React.createElement(Select, __assign({}, props, { options: ['true', 'false'], value: value ? 'true' : 'false', onChange: function (_a) {
            var option = _a.option;
            return onUpdate(option === 'true');
        } })));
};
