/// <reference types="react" />
import { JSONSchema7 as JSONSchema } from 'json-schema';
import { DataTypeEditProps } from '../Filters';
import { InputProps } from '../Input';
export declare const operators: {
    is: {
        getLabel: (_s: JSONSchema) => string;
    };
    is_before: {
        getLabel: (_s: JSONSchema) => string;
    };
    is_after: {
        getLabel: (_s: JSONSchema) => string;
    };
};
declare type OperatorSlug = keyof typeof operators;
interface DateTimeFilter extends JSONSchema {
    title: OperatorSlug;
    properties?: {
        [k: string]: {
            type: 'string';
            format: 'date-time';
            const: string;
            formatMaximum?: string;
            formatMinimum?: string;
        };
    };
}
export declare const decodeFilter: (filter: DateTimeFilter) => {
    field: string;
    operator: OperatorSlug;
    value: string;
} | null;
export declare const createFilter: (field: string, operator: OperatorSlug, value: any, schema: JSONSchema) => DateTimeFilter;
export declare const Edit: ({ value, onUpdate, ...props }: DataTypeEditProps & InputProps & {
    slim?: boolean;
}) => JSX.Element;
export {};
