/// <reference types="react" />
import { JSONSchema7 as JSONSchema } from 'json-schema';
import { DataTypeEditProps } from '../Filters';
export declare const operators: {
    is: {
        getLabel: (_s: JSONSchema) => string;
    };
    is_not: {
        getLabel: (_s: JSONSchema) => string;
    };
    key_is: {
        getLabel: (s: JSONSchema) => string;
    };
    key_contains: {
        getLabel: (s: JSONSchema) => string;
    };
    key_not_contains: {
        getLabel: (s: JSONSchema) => string;
    };
    key_matches_re: {
        getLabel: (s: JSONSchema) => string;
    };
    key_not_matches_re: {
        getLabel: (s: JSONSchema) => string;
    };
    value_is: {
        getLabel: (s: JSONSchema) => string;
    };
    value_contains: {
        getLabel: (s: JSONSchema) => string;
    };
    value_not_contains: {
        getLabel: (s: JSONSchema) => string;
    };
    value_matches_re: {
        getLabel: (s: JSONSchema) => string;
    };
    value_not_matches_re: {
        getLabel: (s: JSONSchema) => string;
    };
};
declare type OperatorSlug = keyof typeof operators;
interface SubSchema {
    title: string;
    properties: {
        [key: string]: {
            const?: string;
            description?: string;
            pattern?: string;
        };
    };
}
interface ObjectFilter extends JSONSchema {
    title: OperatorSlug;
    properties?: {
        [k: string]: {
            contains?: SubSchema;
            not?: {
                contains: SubSchema;
            };
        };
    };
}
export declare const decodeFilter: (filter: ObjectFilter) => {
    field: string;
    operator: OperatorSlug;
    value: {};
} | null;
export declare const createFilter: (field: string, operator: OperatorSlug, value: any, schema: JSONSchema) => JSONSchema;
export declare const Edit: (props: DataTypeEditProps) => JSX.Element;
export {};
