import { TextInputProps as GrommetTextInputProps } from 'grommet';
import * as React from 'react';
import { DefaultProps, Omit, RenditionSystemProps } from '../../common-types';
export interface InternalInputProps extends GrommetTextInputProps, Omit<DefaultProps, 'onSelect'> {
    onChange?: React.ChangeEventHandler<HTMLInputElement>;
    type?: string;
    autoFocus?: boolean;
    autoComplete?: string | boolean;
    readOnly?: boolean;
    disabled?: boolean;
    pattern?: string;
    maxLength?: number;
    form?: string;
    invalid?: boolean;
    valid?: boolean;
    emphasized?: boolean;
    monospace?: boolean;
    list?: string;
}
export declare type InputProps = InternalInputProps & RenditionSystemProps & {
    ref?: React.Ref<HTMLInputElement | null>;
};
declare const _default: React.FunctionComponent<InputProps>;
export default _default;
