/// <reference types="react" />
/// <reference types="googlemaps" />
import { DefaultProps } from '../../common-types';
export interface UIMarker {
    id: string | number;
    lat: number;
    lng: number;
    title?: string;
    icon?: string;
    click?: () => void;
}
declare const Map: <T extends unknown>({ className, data, dataMap, getIcon, onItemClick, apiKey, mapClick, }: MapProps<T>) => JSX.Element;
export interface MapProps<T> extends DefaultProps {
    apiKey: string;
    data: T[];
    dataMap: {
        lat: keyof T | ((item: T) => number | undefined);
        lng: keyof T | ((item: T) => number | undefined);
        id: keyof T | ((item: T) => number | string | undefined);
        title: keyof T | ((item: T) => string | undefined);
    };
    getIcon?: (item: T) => string | undefined;
    onItemClick?: (item: T) => void;
    mapClick?: (e: google.maps.MouseEvent) => void;
}
export default Map;
