import { __assign, __extends, __makeTemplateObject, __rest } from "tslib";
import { faSort } from '@fortawesome/free-solid-svg-icons/faSort';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import every from 'lodash/every';
import filter from 'lodash/filter';
import find from 'lodash/find';
import includes from 'lodash/includes';
import isEqual from 'lodash/isEqual';
import isPlainObject from 'lodash/isPlainObject';
import map from 'lodash/map';
import reject from 'lodash/reject';
import reverse from 'lodash/reverse';
import some from 'lodash/some';
import sortBy from 'lodash/sortBy';
import * as React from 'react';
import styled from 'styled-components';
import Button from '../Button';
import theme from '../../theme';
import { px } from '../../utils';
import Checkbox from '../Checkbox';
import Pager from '../Pager';
import { CheckboxWrapper, TableRow } from './TableRow';
var highlightStyle = "\n\tbackground-color: " + theme.colors.info.light + ";\n";
var BaseTableWrapper = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\toverflow-x: auto;\n\tmax-width: 100%;\n"], ["\n\toverflow-x: auto;\n\tmax-width: 100%;\n"])));
var BaseTable = styled.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tdisplay: table;\n\twidth: 100%;\n\tborder-spacing: 0;\n\tborder-bottom: 1px solid ", ";\n\n\t> [data-display='table-head'] {\n\t\tdisplay: table-header-group;\n\t\tbackground-color: ", ";\n\n\t\t> [data-display='table-row'] {\n\t\t\tdisplay: table-row;\n\n\t\t\t> [data-display='table-cell'] {\n\t\t\t\tdisplay: table-cell;\n\t\t\t\tborder-bottom: 1px solid\n\t\t\t\t\t", ";\n\t\t\t\ttext-align: left;\n\t\t\t\tvertical-align: middle;\n\t\t\t\tpadding: 10px 20px;\n\t\t\t\tfont-size: ", ";\n\t\t\t}\n\n\t\t\t> [data-display='table-cell']:first-child {\n\t\t\t\tpadding-left: ", ";\n\t\t\t\t", ";\n\t\t\t}\n\n\t\t\t> [data-display='table-cell']:last-child {\n\t\t\t\tpadding-right: 40px;\n\t\t\t}\n\t\t}\n\t}\n\n\t> [data-display='table-body'] {\n\t\tdisplay: table-row-group;\n\n\t\t> [data-display='table-row'] {\n\t\t\tdisplay: table-row;\n\t\t\ttext-decoration: none;\n\t\t\tcolor: ", ";\n\t\t\tfont-size: ", ";\n\n\t\t\t> [data-display='table-cell'] {\n\t\t\t\tdisplay: table-cell;\n\t\t\t\ttext-align: left;\n\t\t\t\tvertical-align: middle;\n\t\t\t\tpadding: 14px 20px;\n\t\t\t\ttext-decoration: none;\n\t\t\t\tcolor: inherit;\n\t\t\t}\n\n\t\t\t> [data-display='table-cell']:first-child {\n\t\t\t\tpadding-left: ", ";\n\t\t\t\t", ";\n\t\t\t}\n\n\t\t\t> [data-display='table-cell']:last-child {\n\t\t\t\tpadding-right: 40px;\n\t\t\t}\n\n\t\t\t> a[data-display='table-cell'] {\n\t\t\t\tcursor: ", ";\n\t\t\t}\n\n\t\t\t&:nth-of-type(even) {\n\t\t\t\tbackground-color: ", ";\n\t\t\t}\n\n\t\t\t&:hover {\n\t\t\t\ttext-decoration: none;\n\t\t\t\t", ";\n\t\t\t}\n\n\t\t\t&[data-highlight='true'] {\n\t\t\t\t", " > [data-display=\"table-cell\"]:first-child {\n\t\t\t\t\tbox-shadow: inset 3px 0px 0 ", ";\n\t\t\t\t}\n\t\t\t}\n\t\t}\n\t}\n"], ["\n\tdisplay: table;\n\twidth: 100%;\n\tborder-spacing: 0;\n\tborder-bottom: 1px solid ", ";\n\n\t> [data-display='table-head'] {\n\t\tdisplay: table-header-group;\n\t\tbackground-color: ", ";\n\n\t\t> [data-display='table-row'] {\n\t\t\tdisplay: table-row;\n\n\t\t\t> [data-display='table-cell'] {\n\t\t\t\tdisplay: table-cell;\n\t\t\t\tborder-bottom: 1px solid\n\t\t\t\t\t", ";\n\t\t\t\ttext-align: left;\n\t\t\t\tvertical-align: middle;\n\t\t\t\tpadding: 10px 20px;\n\t\t\t\tfont-size: ", ";\n\t\t\t}\n\n\t\t\t> [data-display='table-cell']:first-child {\n\t\t\t\tpadding-left: ", ";\n\t\t\t\t", ";\n\t\t\t}\n\n\t\t\t> [data-display='table-cell']:last-child {\n\t\t\t\tpadding-right: 40px;\n\t\t\t}\n\t\t}\n\t}\n\n\t> [data-display='table-body'] {\n\t\tdisplay: table-row-group;\n\n\t\t> [data-display='table-row'] {\n\t\t\tdisplay: table-row;\n\t\t\ttext-decoration: none;\n\t\t\tcolor: ", ";\n\t\t\tfont-size: ", ";\n\n\t\t\t> [data-display='table-cell'] {\n\t\t\t\tdisplay: table-cell;\n\t\t\t\ttext-align: left;\n\t\t\t\tvertical-align: middle;\n\t\t\t\tpadding: 14px 20px;\n\t\t\t\ttext-decoration: none;\n\t\t\t\tcolor: inherit;\n\t\t\t}\n\n\t\t\t> [data-display='table-cell']:first-child {\n\t\t\t\tpadding-left: ", ";\n\t\t\t\t", ";\n\t\t\t}\n\n\t\t\t> [data-display='table-cell']:last-child {\n\t\t\t\tpadding-right: 40px;\n\t\t\t}\n\n\t\t\t> a[data-display='table-cell'] {\n\t\t\t\tcursor: ",
    ";\n\t\t\t}\n\n\t\t\t&:nth-of-type(even) {\n\t\t\t\tbackground-color: ", ";\n\t\t\t}\n\n\t\t\t&:hover {\n\t\t\t\ttext-decoration: none;\n\t\t\t\t",
    ";\n\t\t\t}\n\n\t\t\t&[data-highlight='true'] {\n\t\t\t\t", " > [data-display=\"table-cell\"]:first-child {\n\t\t\t\t\tbox-shadow: inset 3px 0px 0 ", ";\n\t\t\t\t}\n\t\t\t}\n\t\t}\n\t}\n"])), function (props) { return props.theme.colors.quartenary.main; }, function (props) { return props.theme.colors.quartenary.light; }, function (props) { return props.theme.colors.quartenary.main; }, function (props) { return px(props.theme.fontSizes[2]); }, function (props) { return (props.hasCheckbox ? '20px' : '40px'); }, function (props) { return (props.hasCheckbox ? 'width: 60px' : ''); }, function (props) { return props.theme.colors.secondary.main; }, function (props) { return px(props.theme.fontSizes[2]); }, function (props) { return (props.hasCheckbox ? '20px' : '40px'); }, function (props) { return (props.hasCheckbox ? 'width: 60px' : ''); }, function (props) {
    return props.hasRowClick || props.hasGetRowRef ? 'pointer' : 'auto';
}, function (props) { return props.theme.colors.quartenary.light; }, function (props) {
    return props.hasRowClick || props.hasGetRowRef || props.hasCheckbox
        ? highlightStyle
        : '';
}, highlightStyle, function (props) { return props.theme.colors.info.main; });
var HeaderButton = styled(Button)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n\tdisplay: block;\n"], ["\n\tdisplay: block;\n"])));
var Table = (function (_super) {
    __extends(Table, _super);
    function Table(props) {
        var _this = _super.call(this, props) || this;
        _this.setRowSelection = function (selectedRows) {
            var _a = _this.props, rowKey = _a.rowKey, data = _a.data;
            if (!rowKey) {
                return;
            }
            if (selectedRows.length === 0) {
                _this.setState({ allChecked: false, checkedItems: [] });
                return;
            }
            var selectedRowsIds = map(selectedRows, rowKey);
            var checkedItems = [];
            var allChecked = false;
            if (data) {
                checkedItems = filter(_this.props.data, function (x) {
                    return includes(selectedRowsIds, x[rowKey]);
                });
                allChecked = data.length > 0 && checkedItems.length === data.length;
            }
            _this.setState({ allChecked: allChecked, checkedItems: checkedItems });
        };
        _this.toggleAllChecked = function () {
            var data = _this.props.data;
            var allChecked = !_this.state.allChecked;
            var checkedItems = allChecked
                ? (data || []).slice().filter(function (r) { return !_this.isDisabled(r); })
                : [];
            if (_this.props.onCheck) {
                _this.props.onCheck(checkedItems);
            }
            _this.setState({ allChecked: allChecked, checkedItems: checkedItems });
        };
        _this.toggleChecked = function (e) {
            var _a;
            var rowKey = _this.props.rowKey;
            var key = e.currentTarget.dataset.key;
            if (!rowKey || !key) {
                return false;
            }
            var item = _this.getElementFromKey(key);
            if (!item) {
                return;
            }
            var identifier = item[rowKey];
            var isChecked = !_this.isChecked(item);
            var checkedItems = isChecked
                ? _this.state.checkedItems.concat(item)
                : reject(_this.state.checkedItems, (_a = {},
                    _a[rowKey] = identifier,
                    _a));
            if (_this.props.onCheck) {
                _this.props.onCheck(checkedItems);
            }
            _this.setState({
                allChecked: _this.isEachRowChecked(checkedItems),
                checkedItems: checkedItems,
            });
        };
        _this.toggleSort = function (e) {
            var field = e.currentTarget.dataset.field;
            var sort = _this.state.sort;
            if (!field) {
                return;
            }
            var nextSort = {
                field: field,
                reverse: false,
            };
            if (sort.field === field) {
                nextSort = { field: sort.field, reverse: !sort.reverse };
            }
            _this.setState({ sort: nextSort });
            if (_this.props.onSort) {
                _this.props.onSort(nextSort);
            }
        };
        _this.onRowClick = function (e) {
            if (!_this.props.onRowClick) {
                return;
            }
            if (!_this.props.rowKey) {
                return console.warn('onRowClick requires that you provide a `rowKey` property');
            }
            var key = e.currentTarget.dataset.key;
            if (!key) {
                return console.warn('onRowClick called on an element without a key set');
            }
            var row = _this.getElementFromKey(key);
            if (row) {
                _this.props.onRowClick(row, e);
            }
        };
        _this.setPage = function (change) {
            if (_this.props.onPageChange) {
                _this.props.onPageChange(change);
            }
            _this.setState({ page: change });
        };
        _this.resetPager = function () {
            _this.setPage(0);
        };
        _this.incrementPage = function () {
            _this.setPage(_this.state.page + 1);
        };
        _this.decrementPage = function () {
            _this.setPage(_this.state.page - 1);
        };
        if (props.onCheck && !props.rowKey) {
            throw new Error('A `rowKey` property must be provided if using `onCheck` with a Table component');
        }
        var sortState = props.sort || {
            reverse: false,
            field: null,
        };
        _this.state = {
            allChecked: false,
            sort: sortState,
            checkedItems: [],
            page: 0,
        };
        return _this;
    }
    Table.prototype.componentDidUpdate = function (prevProps) {
        var _a, _b, _c;
        if (this.props.sort && !isEqual(prevProps.sort, this.props.sort)) {
            this.setState({
                sort: this.props.sort,
            });
        }
        var totalItems = (_b = (_a = this.props.data) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0;
        var itemsPerPage = (_c = this.props.itemsPerPage) !== null && _c !== void 0 ? _c : 50;
        if (this.state.page !== 0 && totalItems <= this.state.page * itemsPerPage) {
            this.resetPager();
        }
    };
    Table.prototype.isChecked = function (item) {
        var _a;
        var rowKey = this.props.rowKey;
        if (!rowKey) {
            return false;
        }
        var identifier = item[rowKey];
        return some(this.state.checkedItems, (_a = {}, _a[rowKey] = identifier, _a));
    };
    Table.prototype.isHighlighted = function (item) {
        if (!this.props.highlightedRows ||
            this.props.highlightedRows.length === 0) {
            return false;
        }
        var rowKey = this.props.rowKey;
        if (!rowKey) {
            return false;
        }
        var identifier = item[rowKey];
        return includes(this.props.highlightedRows, identifier);
    };
    Table.prototype.isDisabled = function (item) {
        if (!this.props.disabledRows || this.props.disabledRows.length === 0) {
            return false;
        }
        var rowKey = this.props.rowKey;
        if (!rowKey) {
            return false;
        }
        var identifier = item[rowKey];
        return includes(this.props.disabledRows, identifier);
    };
    Table.prototype.isEachRowChecked = function (checkedItems) {
        var rowKey = this.props.rowKey;
        if (!rowKey) {
            return false;
        }
        var selectedKeys = map(checkedItems, rowKey);
        return every(this.props.data, function (x) { return includes(selectedKeys, x[rowKey]); });
    };
    Table.prototype.sortData = function (data) {
        var sort = this.state.sort;
        if (!sort || sort.field === null) {
            return data;
        }
        var column = find(this.props.columns, { field: sort.field });
        if (!column) {
            return data;
        }
        var collection;
        if (typeof column.sortable === 'function') {
            collection = data.slice().sort(column.sortable);
        }
        else {
            collection = sortBy(data.slice(), function (item) {
                var sortableValue = item[sort.field];
                return isPlainObject(sortableValue)
                    ? sortableValue.value
                    : sortableValue;
            });
        }
        if (sort.reverse) {
            reverse(collection);
        }
        return collection;
    };
    Table.prototype.getElementFromKey = function (key) {
        var _a = this.props, data = _a.data, rowKey = _a.rowKey;
        if (!data) {
            return;
        }
        if (rowKey) {
            return find(data, function (element) { return "" + element[rowKey] === key; });
        }
        return data[Number(key)];
    };
    Table.prototype.render = function () {
        var _this = this;
        var _a = this.props, columns = _a.columns, data = _a.data, usePager = _a.usePager, itemsPerPage = _a.itemsPerPage, pagerPosition = _a.pagerPosition, rowAnchorAttributes = _a.rowAnchorAttributes, rowKey = _a.rowKey, onCheck = _a.onCheck, onRowClick = _a.onRowClick, getRowHref = _a.getRowHref, getRowClass = _a.getRowClass, props = __rest(_a, ["columns", "data", "usePager", "itemsPerPage", "pagerPosition", "rowAnchorAttributes", "rowKey", "onCheck", "onRowClick", "getRowHref", "getRowClass"]);
        var _b = this.state, page = _b.page, sort = _b.sort;
        var items = data || [];
        var totalItems = items.length;
        var _itemsPerpage = itemsPerPage || 50;
        var _pagerPosition = pagerPosition || 'top';
        var lowerBound = usePager ? page * _itemsPerpage : 0;
        var upperBound = usePager
            ? Math.min((page + 1) * _itemsPerpage, totalItems)
            : totalItems;
        var sortedData = this.sortData(items).slice(lowerBound, upperBound);
        var shouldShowPaper = !!usePager && totalItems > 0;
        return (React.createElement(React.Fragment, null,
            shouldShowPaper &&
                (_pagerPosition === 'top' || _pagerPosition === 'both') && (React.createElement(Pager, { totalItems: totalItems, itemsPerPage: _itemsPerpage, page: page, nextPage: this.incrementPage, prevPage: this.decrementPage, mb: 2 })),
            React.createElement(BaseTableWrapper, null,
                React.createElement(BaseTable, __assign({}, props, { hasRowClick: !!onRowClick, hasGetRowRef: !!getRowHref, hasCheckbox: !!onCheck }),
                    React.createElement("div", { "data-display": "table-head" },
                        React.createElement("div", { "data-display": "table-row" },
                            onCheck && (React.createElement(CheckboxWrapper, { "data-display": "table-cell" },
                                React.createElement(Checkbox, { checked: this.state.allChecked, onChange: this.toggleAllChecked }))),
                            map(columns, function (item) {
                                if (item.sortable) {
                                    return (React.createElement("div", { "data-display": "table-cell", key: item.key || item.field },
                                        React.createElement(HeaderButton, { "data-field": item.field, plain: true, primary: sort.field === item.field, onClick: _this.toggleSort },
                                            item.label || item.field,
                                            "\u00A0",
                                            React.createElement(FontAwesomeIcon, { icon: faSort, color: sort.field === item.field
                                                    ? theme.colors.info.main
                                                    : '' }))));
                                }
                                return (React.createElement("div", { "data-display": "table-cell", key: item.key || item.field }, item.label || item.field));
                            }))),
                    React.createElement("div", { "data-display": "table-body" },
                        this.props.tbodyPrefix,
                        map(sortedData, function (row, i) {
                            var isChecked = onCheck ? _this.isChecked(row) : false;
                            var isHighlighted = _this.isHighlighted(row);
                            var isDisabled = _this.isDisabled(row);
                            var key = rowKey ? row[rowKey] : i;
                            var href = !!getRowHref ? getRowHref(row) : undefined;
                            var classNamesList = typeof getRowClass === 'function' ? getRowClass(row) : [];
                            var className = Array.isArray(classNamesList)
                                ? classNamesList.join(' ')
                                : '';
                            return (React.createElement(TableRow, { isChecked: isChecked, isHighlighted: isHighlighted, isDisabled: isDisabled, key: key, keyAttribute: key, href: href, data: row, showCheck: !!onCheck, columns: columns, attributes: rowAnchorAttributes, checkboxAttributes: _this.props.rowCheckboxAttributes, toggleChecked: _this.toggleChecked, onRowClick: _this.onRowClick, className: className }));
                        })))),
            shouldShowPaper &&
                (_pagerPosition === 'bottom' || _pagerPosition === 'both') && (React.createElement(Pager, { totalItems: totalItems, itemsPerPage: _itemsPerpage, page: page, nextPage: this.incrementPage, prevPage: this.decrementPage, mt: 2 }))));
    };
    return Table;
}(React.Component));
export { TableRow };
export default Table;
var templateObject_1, templateObject_2, templateObject_3;
