import { __assign, __rest } from "tslib";
import * as React from 'react';
import isArray from 'lodash/isArray';
import get from 'lodash/get';
import map from 'lodash/map';
import Button from '../../../components/Button';
import ButtonGroup from '../../../components/ButtonGroup';
import { JsonTypes } from '../types';
import ButtonWidget from './ButtonWidget';
var validItemTypes = ['string', 'integer', 'number'];
var ButtonGroupWidget = function (_a) {
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema, props = __rest(_a, ["value", "schema", "uiSchema"]);
    if (!isArray(value)) {
        throw new Error("ButtonGroupWidget cannot be used to render a value of type '" + typeof value + "'");
    }
    var itemType = get(schema, ['items', 'type'], 'undefined');
    if (!validItemTypes.includes(itemType)) {
        throw new Error("ButtonGroupWidget cannot be used to render an array of items of type " + itemType);
    }
    return (React.createElement(ButtonGroup, null, map(value, function (item) { return (React.createElement(Button, __assign({ key: item }, props), item.toString())); })));
};
ButtonGroupWidget.uiOptions = ButtonWidget.uiOptions;
ButtonGroupWidget.supportedTypes = [JsonTypes.array];
export default ButtonGroupWidget;
