import { __assign, __rest } from "tslib";
import * as React from 'react';
import noop from 'lodash/noop';
import Checkbox from '../../../components/Checkbox';
import { UiOption } from './ui-options';
import { JsonTypes } from '../types';
var CheckboxWidget = function (_a) {
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema, props = __rest(_a, ["value", "schema", "uiSchema"]);
    return React.createElement(Checkbox, __assign({}, props, { checked: Boolean(value), onChange: noop }));
};
CheckboxWidget.uiOptions = {
    label: UiOption.string,
    reverse: UiOption.boolean,
    toggle: UiOption.boolean,
};
CheckboxWidget.supportedTypes = [JsonTypes.boolean];
export default CheckboxWidget;
