import { __assign, __rest } from "tslib";
import * as React from 'react';
import isArray from 'lodash/isArray';
import get from 'lodash/get';
import map from 'lodash/map';
import DropDownButton from '../../../components/DropDownButton';
import ButtonWidget from './ButtonWidget';
import { JsonTypes } from '../types';
import { UiOption } from './ui-options';
var validItemTypes = ['string', 'integer', 'number'];
var DropDownButtonWidget = function (_a) {
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema, props = __rest(_a, ["value", "schema", "uiSchema"]);
    if (!isArray(value)) {
        throw new Error("DropDownButtonWidget cannot be used to render a value of type '" + typeof value + "'");
    }
    var itemType = get(schema, ['items', 'type'], 'undefined');
    if (!validItemTypes.includes(itemType)) {
        throw new Error("DropDownButtonWidget cannot be used to render an array of items of type " + itemType);
    }
    return (React.createElement(DropDownButton, __assign({}, props), map(value, function (item) { return (React.createElement("div", { key: item }, item.toString())); })));
};
DropDownButtonWidget.uiOptions = __assign(__assign({}, ButtonWidget.uiOptions), { label: UiOption.string });
DropDownButtonWidget.supportedTypes = [JsonTypes.array];
export default DropDownButtonWidget;
