import { __assign, __rest } from "tslib";
import * as React from 'react';
import map from 'lodash/map';
import List from '../../../components/List';
import { getArrayItems } from './widget-util';
import { RenditionJsonSchemaRenderer } from '../index';
import { JsonTypes } from '../types';
import { UiOption } from './ui-options';
var ListWidget = function (_a) {
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema, truncate = _a.truncate, extraFormats = _a.extraFormats, extraContext = _a.extraContext, props = __rest(_a, ["value", "schema", "uiSchema", "truncate", "extraFormats", "extraContext"]);
    var items = getArrayItems({ value: value, schema: schema, uiSchema: uiSchema, extraContext: extraContext });
    return (React.createElement(List, __assign({}, props), map(items, function (item, index) {
        return (React.createElement(RenditionJsonSchemaRenderer, __assign({ key: index, nested: true }, item, { extraFormats: extraFormats })));
    })));
};
ListWidget.uiOptions = {
    truncate: UiOption.integer,
    ordered: UiOption.boolean,
};
ListWidget.supportedTypes = [JsonTypes.array];
export default ListWidget;
