import { __assign, __rest } from "tslib";
import * as React from 'react';
import get from 'lodash/get';
import map from 'lodash/map';
import { getObjectPropertyNames } from './widget-util';
import { JsonTypes } from '../types';
import { RenditionJsonSchemaRenderer } from '../index';
var ObjectWidget = function (_a) {
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema, rest = __rest(_a, ["value", "schema", "uiSchema"]);
    var propertyNames = getObjectPropertyNames({ value: value, schema: schema, uiSchema: uiSchema });
    return (React.createElement(React.Fragment, null, map(propertyNames, function (key) {
        var subProps = {
            value: get(value, key),
            schema: get(schema, ['properties', key]),
            uiSchema: get(uiSchema, key),
        };
        return (React.createElement(RenditionJsonSchemaRenderer, __assign({ key: key, nested: true, valueKey: key }, subProps, rest)));
    })));
};
ObjectWidget.supportedTypes = [JsonTypes.object];
export default ObjectWidget;
