import { __assign, __makeTemplateObject, __rest } from "tslib";
import * as React from 'react';
import get from 'lodash/get';
import invokeMap from 'lodash/invokeMap';
import isArray from 'lodash/isArray';
import styled from 'styled-components';
import Txt from '../../../components/Txt';
import { JsonTypes } from '../types';
import { UiOption } from './ui-options';
var SingleLineTxt = styled(Txt)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\twhite-space: nowrap;\n\toverflow: hidden;\n\ttext-overflow: ellipsis;\n\tmax-width: 100%;\n"], ["\n\twhite-space: nowrap;\n\toverflow: hidden;\n\ttext-overflow: ellipsis;\n\tmax-width: 100%;\n"])));
var getArrayValue = function (value, uiSchema) {
    var maxItems = get(uiSchema, ['ui:options', 'truncate'], value.length);
    var arrayString = invokeMap(value.slice(0, maxItems), 'toString').join(', ');
    if (maxItems < value.length) {
        arrayString += " and " + (value.length - maxItems) + " more...";
    }
    return arrayString;
};
var TxtWidget = function (_a) {
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema, props = __rest(_a, ["value", "schema", "uiSchema"]);
    var displayValue = isArray(value)
        ? getArrayValue(value, uiSchema)
        : value === null || value === void 0 ? void 0 : value.toString();
    var Component = get(uiSchema, ['ui:options', 'truncate'])
        ? SingleLineTxt
        : Txt;
    return React.createElement(Component, __assign({}, props), displayValue || '');
};
TxtWidget.uiOptions = {
    bold: UiOption.boolean,
    italic: UiOption.boolean,
    monospace: UiOption.boolean,
    caps: UiOption.boolean,
    align: __assign(__assign({}, UiOption.string), { enum: [
            'left',
            'right',
            'center',
            'justify',
            'justify-all',
            'start',
            'end',
            'match-parent',
            'inherit',
            'initial',
            'unset',
        ] }),
    whitespace: __assign(__assign({}, UiOption.string), { enum: [
            'normal',
            'nowrap',
            'pre',
            'pre-line',
            'pre-wrap',
            'initial',
            'inherit',
        ] }),
};
TxtWidget.supportedTypes = [
    JsonTypes.string,
    JsonTypes.null,
    JsonTypes.integer,
    JsonTypes.number,
    JsonTypes.boolean,
    JsonTypes.array,
];
export default TxtWidget;
var templateObject_1;
