import * as React from 'react';
import get from 'lodash/get';
import { Box } from '../../../components/Box';
import Txt from '../../../components/Txt';
export default function WidgetMeta(_a) {
    var valueKey = _a.valueKey, _b = _a.schema, schema = _b === void 0 ? {} : _b, _c = _a.uiSchema, uiSchema = _c === void 0 ? {} : _c;
    var title = get(uiSchema, 'ui:title', schema.title || valueKey);
    var description = get(uiSchema, 'ui:description', schema.description);
    if (!title && !description) {
        return null;
    }
    return (React.createElement(Box, { mr: 2 },
        title && React.createElement(Txt, { bold: true }, title),
        description && (React.createElement(Txt, { fontSize: "85%", color: "text.light" }, description))));
}
