import { __assign } from "tslib";
var responsive = function (schema) {
    return {
        anyOf: [
            {
                type: 'array',
                items: schema,
            },
            __assign({}, schema),
        ],
    };
};
export var UiOption = {
    string: {
        type: 'string',
    },
    boolean: {
        type: 'boolean',
    },
    number: {
        type: 'number',
    },
    integer: {
        type: 'integer',
    },
    space: responsive({
        type: ['number', 'string'],
    }),
};
export var SpaceUiOptions = {};
[
    'p',
    'pt',
    'pb',
    'pl',
    'pr',
    'px',
    'py',
    'm',
    'mt',
    'mb',
    'ml',
    'mr',
    'mx',
    'my',
].reduce(function (options, option) {
    options[option] = UiOption.space;
    return options;
}, SpaceUiOptions);
export var FlexUiOptions = {
    flex: responsive({
        type: ['number', 'string'],
    }),
    flexDirection: responsive({
        type: 'string',
        enum: ['column', 'row', 'column-reverse', 'row-reverse'],
    }),
    flexBasis: responsive({
        type: 'string',
    }),
    flexWrap: responsive({
        type: 'string',
        enum: ['nowrap', 'wrap', 'wrap-reverse', 'initial', 'inherit'],
    }),
    alignItems: responsive({
        type: 'string',
        enum: [
            'stretch',
            'center',
            'flex-start',
            'flex-end',
            'baseline',
            'initial',
            'inherit',
        ],
    }),
    alignSelf: responsive({
        type: 'string',
        enum: [
            'auto',
            'stretch',
            'center',
            'flex-start',
            'flex-end',
            'baseline',
            'initial',
            'inherit',
        ],
    }),
    justifyContent: responsive({
        type: 'string',
        enum: [
            'flex-start',
            'flex-end',
            'center',
            'space-between',
            'space-around',
            'initial',
            'inherit',
        ],
    }),
    justifySelf: responsive({
        type: 'string',
        enum: [
            'auto',
            'normal',
            'stretch',
            'center',
            'start',
            'end',
            'flex-start',
            'flex-end',
            'self-start',
            'self-end',
            'left',
            'right',
            'baseline',
            'initial',
            'inherit',
            'unset',
        ],
    }),
};
export var WidgetWrapperUiOptions = __assign(__assign({}, SpaceUiOptions), FlexUiOptions);
