/// <reference types="react" />
import { DefinedValue, JSONSchema, UiSchema, Format, Value } from '../types';
import { UiOptions } from './ui-options';
export interface WidgetProps {
    value: DefinedValue;
    schema: JSONSchema;
    uiSchema?: UiSchema;
    extraFormats?: Format[];
    extraContext?: object;
}
export interface Widget {
    (props: WidgetProps): JSX.Element | null;
    uiOptions?: UiOptions;
    supportedTypes?: string[];
}
export declare function withOptionProps(uiOptions: UiOptions): (Component: Widget) => {
    (props: WidgetProps): JSX.Element;
    uiOptions: UiOptions | undefined;
    supportedTypes: string[] | undefined;
};
export declare const transformUiSchema: ({ value, uiSchema, extraContext, }: {
    value?: string | number | boolean | any[] | {
        [key: string]: any;
    } | null | undefined;
    uiSchema: WidgetProps['uiSchema'];
    extraContext: WidgetProps['extraContext'];
}) => any;
export declare const getArrayItems: ({ value, schema, uiSchema, extraContext, }: WidgetProps) => WidgetProps[];
export declare function getObjectPropertyNames({ value, schema, uiSchema, }: WidgetProps): string[];
