import { __assign, __makeTemplateObject, __rest, __spreadArrays } from "tslib";
import * as React from 'react';
import Txt from '../../components/Txt';
import Heading from '../../components/Heading';
import Link from '../../components/Link';
import unified from 'unified';
import remarkParse from 'remark-parse';
import remarkRehype from 'remark-rehype';
import rehypeReact from 'rehype-react';
import sanitize from 'rehype-sanitize';
import raw from 'rehype-raw';
import prism from '@mapbox/rehype-prism';
import Divider from '../../components/Divider';
import styled, { withTheme } from 'styled-components';
import gh from 'hast-util-sanitize/lib/github.json';
import 'prismjs/themes/prism.css';
import { darken, lighten } from '../../utils';
export { gh as defaultSanitizerOptions };
var MarkdownWrapper = styled(Txt)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t* {\n\t\tbox-sizing: border-box;\n\t}\n\n\t& code {\n\t\tbackground-color: ", ";\n\t\tpadding: 0.2em 0px;\n\t\tmargin: 0px;\n\t\tborder-radius: 3px;\n\t\tline-height: 1.2;\n\t}\n\n\t& pre {\n\t\tbackground-color: ", ";\n\t}\n\n\t& pre > code {\n\t\tbackground: none;\n\t}\n\n\t& code,\n\tkbd,\n\tpre {\n\t\tfont-family: ", ";\n\t}\n\n\t& kbd {\n\t\tdisplay: inline-block;\n\t\tpadding: 3px 5px;\n\t\tfont-size: 11px;\n\t\tline-height: 10px;\n\t\tcolor: ", ";\n\t\tvertical-align: middle;\n\t\tbackground-color: ", ";\n\t\tborder: solid 1px ", ";\n\t\tborder-bottom-color: ", ";\n\t\tborder-radius: 3px;\n\t\tbox-shadow: inset 0 -1px 0 ", ";\n\t}\n\n\tdl {\n\t\tpadding: 0;\n\t}\n\n\tdl dt {\n\t\tpadding: 0;\n\t\tmargin-top: 16px;\n\t\tfont-size: 1em;\n\t\tfont-style: italic;\n\t\tfont-weight: ", ";\n\t}\n\n\tdl dd {\n\t\tpadding: 0 16px;\n\t\tmargin-bottom: 16px;\n\t}\n\n\ttd,\n\tth {\n\t\tpadding: 0;\n\t}\n\n\ttable {\n\t\tborder-spacing: 0;\n\t\tborder-collapse: collapse;\n\t\tdisplay: block;\n\t\twidth: 100%;\n\t\toverflow: auto;\n\t}\n\n\ttable th {\n\t\tfont-weight: ", ";\n\t}\n\n\ttable th,\n\ttable td {\n\t\tpadding: 6px 13px;\n\t\tborder: 1px solid ", ";\n\t}\n\n\ttable tr {\n\t\tbackground-color: #fff;\n\t\tborder-top: 1px solid ", ";\n\t}\n\n\ttable tr:nth-child(2n) {\n\t\tbackground-color: ", ";\n\t}\n\n\tblockquote {\n\t\tmargin: 0;\n\t}\n\n\tblockquote,\n\tdl,\n\ttable {\n\t\tmargin-top: 0;\n\t\tmargin-bottom: 16px;\n\t}\n\n\tblockquote {\n\t\tpadding: 0 1em;\n\t\tcolor: ", ";\n\t\tborder-left: 0.25em solid ", ";\n\t}\n\n\tblockquote > :first-child {\n\t\tmargin-top: 0;\n\t}\n\n\tblockquote > :last-child {\n\t\tmargin-bottom: 0;\n\t}\n"], ["\n\t* {\n\t\tbox-sizing: border-box;\n\t}\n\n\t& code {\n\t\tbackground-color: ", ";\n\t\tpadding: 0.2em 0px;\n\t\tmargin: 0px;\n\t\tborder-radius: 3px;\n\t\tline-height: 1.2;\n\t}\n\n\t& pre {\n\t\tbackground-color: ", ";\n\t}\n\n\t& pre > code {\n\t\tbackground: none;\n\t}\n\n\t& code,\n\tkbd,\n\tpre {\n\t\tfont-family: ", ";\n\t}\n\n\t& kbd {\n\t\tdisplay: inline-block;\n\t\tpadding: 3px 5px;\n\t\tfont-size: 11px;\n\t\tline-height: 10px;\n\t\tcolor: ", ";\n\t\tvertical-align: middle;\n\t\tbackground-color: ", ";\n\t\tborder: solid 1px ", ";\n\t\tborder-bottom-color: ",
    ";\n\t\tborder-radius: 3px;\n\t\tbox-shadow: inset 0 -1px 0 ", ";\n\t}\n\n\tdl {\n\t\tpadding: 0;\n\t}\n\n\tdl dt {\n\t\tpadding: 0;\n\t\tmargin-top: 16px;\n\t\tfont-size: 1em;\n\t\tfont-style: italic;\n\t\tfont-weight: ", ";\n\t}\n\n\tdl dd {\n\t\tpadding: 0 16px;\n\t\tmargin-bottom: 16px;\n\t}\n\n\ttd,\n\tth {\n\t\tpadding: 0;\n\t}\n\n\ttable {\n\t\tborder-spacing: 0;\n\t\tborder-collapse: collapse;\n\t\tdisplay: block;\n\t\twidth: 100%;\n\t\toverflow: auto;\n\t}\n\n\ttable th {\n\t\tfont-weight: ", ";\n\t}\n\n\ttable th,\n\ttable td {\n\t\tpadding: 6px 13px;\n\t\tborder: 1px solid ", ";\n\t}\n\n\ttable tr {\n\t\tbackground-color: #fff;\n\t\tborder-top: 1px solid ", ";\n\t}\n\n\ttable tr:nth-child(2n) {\n\t\tbackground-color: ", ";\n\t}\n\n\tblockquote {\n\t\tmargin: 0;\n\t}\n\n\tblockquote,\n\tdl,\n\ttable {\n\t\tmargin-top: 0;\n\t\tmargin-bottom: 16px;\n\t}\n\n\tblockquote {\n\t\tpadding: 0 1em;\n\t\tcolor: ", ";\n\t\tborder-left: 0.25em solid ", ";\n\t}\n\n\tblockquote > :first-child {\n\t\tmargin-top: 0;\n\t}\n\n\tblockquote > :last-child {\n\t\tmargin-bottom: 0;\n\t}\n"])), function (props) { return props.theme.colors.gray.light; }, function (props) { return props.theme.colors.gray.light; }, function (props) { return props.theme.monospace; }, function (props) { return props.theme.colors.text.main; }, function (props) { return lighten(props.theme.colors.gray.light); }, function (props) { return props.theme.colors.gray.main; }, function (props) {
    return darken(props.theme.colors.gray.main, 0.1);
}, function (props) { return darken(props.theme.colors.gray.main, 0.1); }, function (props) { return props.theme.weights[1]; }, function (props) { return props.theme.weights[1]; }, function (props) { return props.theme.colors.gray.main; }, function (props) { return props.theme.colors.gray.light; }, function (props) { return props.theme.colors.gray.light; }, function (props) { return props.theme.colors.text.main; }, function (props) { return props.theme.colors.gray.main; });
export var getProcessor = function (componentOverrides, sanitizerOptions, disableRawHtml, disableCodeHighlight) {
    var processor = unified()
        .use(remarkParse, { gfm: true })
        .use(remarkRehype, { allowDangerousHtml: !disableRawHtml });
    if (!disableCodeHighlight) {
        processor = processor.use(prism);
    }
    if (!disableRawHtml) {
        processor = processor.use(raw);
    }
    if (sanitizerOptions !== null) {
        processor = processor.use(sanitize, sanitizerOptions !== null && sanitizerOptions !== void 0 ? sanitizerOptions : __assign(__assign({}, gh), { attributes: __assign(__assign({}, gh.attributes), { '*': __spreadArrays(gh.attributes['*'], ['class', 'className']) }) }));
    }
    return processor.use(rehypeReact, {
        createElement: React.createElement,
        components: __assign({ p: function (props) { return React.createElement(Txt.p, __assign({}, props)); }, a: function (props) { return React.createElement(Link, __assign({}, props)); }, h1: function (props) { return React.createElement(Heading.h1, __assign({}, props)); }, h2: function (props) { return React.createElement(Heading.h2, __assign({}, props)); }, h3: function (props) { return React.createElement(Heading.h3, __assign({}, props)); }, h4: function (props) { return React.createElement(Heading.h4, __assign({}, props)); }, h5: function (props) { return React.createElement(Heading.h5, __assign({}, props)); }, h6: function (props) { return React.createElement(Heading.h6, __assign({}, props)); }, hr: function (props) { return React.createElement(Divider, __assign({}, props)); } }, componentOverrides),
    });
};
export var MarkdownBase = function (_a) {
    var children = _a.children, componentOverrides = _a.componentOverrides, sanitizerOptions = _a.sanitizerOptions, disableRawHtml = _a.disableRawHtml, disableCodeHighlight = _a.disableCodeHighlight, props = __rest(_a, ["children", "componentOverrides", "sanitizerOptions", "disableRawHtml", "disableCodeHighlight"]);
    return (React.createElement(MarkdownWrapper, __assign({}, props), getProcessor(componentOverrides, sanitizerOptions, disableRawHtml, disableCodeHighlight).processSync(children).result));
};
export var Markdown = withTheme(MarkdownBase);
var templateObject_1;
